package com.github.eildosa.app;

import org.lwjgl.opengl.GL11;

/**
 * 
 * This class contains a collection (just one as of now) of static method used to draw
 * stuff on the screen.
 * 
 * 
 * @author athongvan2
 *
 */

public class Draw {
	
	
	/**
	 * Draw a colorfull cube using square
	 * @param xRot : rotation in x
	 * @param yRot : rotation in y
	 * @param zRot : rotation in z
	 * @param size : size of the cube
	 */
	public static void cubeHereColorfulUsingTriangle(float xRot, float yRot, float zRot, float size){
		
		//rotation
    	GL11.glRotatef(xRot, 1.0f, 0.0f, 0.0f); //rotation en x
    	GL11.glRotatef(yRot, 0.0f, 1.0f, 0.0f); //rotation en y
    	GL11.glRotatef(zRot, 0.0f, 0.0f, 1.0f); //rotation en z
    	
    	//dessin du cube
    	GL11.glBegin(GL11.GL_TRIANGLES);
    	//couleur
    	
    	//face de devant
    	GL11.glNormal3f( 0.0f, 0.0f, 1.0f);// Normale pointant vers le joueur
    	
    	GL11.glColor3f(1, 0, 0); //couleur
    	GL11.glVertex3f(-size, -size, size);//vertex en bas a gauche
    	GL11.glColor3f(0, 1, 0); //couleur
    	GL11.glVertex3f(size, -size, size);//vertex en bas a droite
    	GL11.glColor3f(0, 0,1); //couleur
    	GL11.glVertex3f(size, size, size);//vertex en haut a droite
    	
    	GL11.glColor3f(1, 0, 1); //couleur
    	GL11.glVertex3f(-size, size, size);//vertex en haut a gauche
    	GL11.glColor3f(0, 0,1); //couleur
    	GL11.glVertex3f(size, size, size);//vertex en haut a droite
    	GL11.glColor3f(1, 0, 0); //couleur
    	GL11.glVertex3f(-size, -size, size);//vertex en bas a gauche
   
    	
    	//face arriere
    	GL11.glNormal3f( 0.0f, 0.0f,-1.0f);// Normale partant vers le fond
    	GL11.glColor3f(1, 0, 0); //couleur
    	GL11.glVertex3f(-size, -size, -size);//en bas a gauche
    	GL11.glColor3f(0, 1, 0); //couleur
    	GL11.glVertex3f(-size, size, -size);//en haut a gauche
    	GL11.glColor3f(0, 0,1); //couleur
    	GL11.glVertex3f(size, size, -size);//en haut a droite
    	
    	GL11.glColor3f(1, 0, 1); //couleur
    	GL11.glVertex3f(size, -size, -size);//en bas a droite
    	GL11.glColor3f(0, 0,1); //couleur
    	GL11.glVertex3f(size, size, -size);//en haut a droite
    	GL11.glColor3f(1, 0, 0); //couleur
    	GL11.glVertex3f(-size, -size, -size);//en bas a gauche

    	
    	//face de dessus
    	GL11.glNormal3f( 0.0f, 1.0f, 0.0f);//Normale qui pointe en haut
    	GL11.glColor3f(1, 0, 0); //couleur
    	GL11.glVertex3f(-size, size, -size);//arriere gauche
    	GL11.glColor3f(0, 1, 0); //couleur
    	GL11.glVertex3f(-size, size, size);//avant gauche
    	GL11.glColor3f(0, 0,1); //couleur
    	GL11.glVertex3f(size, size, size); //avant droite
    	
    	GL11.glColor3f(1, 0, 1); //couleur
    	GL11.glVertex3f(size, size, -size); // arriere droite
    	GL11.glColor3f(1, 0, 0); //couleur
    	GL11.glVertex3f(-size, size, -size);//arriere gauche
    	GL11.glColor3f(0, 0,1); //couleur
    	GL11.glVertex3f(size, size, size); //avant droite

    	
    	//face du bas
    	GL11.glNormal3f( 0.0f,-1.0f, 0.0f); //Normale qui pointe en bas
    	GL11.glColor3f(1, 0, 0); //couleur
    	GL11.glVertex3f(-size, -size, -size); //arriere gauche
    	GL11.glColor3f(0, 1, 0); //couleur
    	GL11.glVertex3f(size, -size, -size); //arriere droite
    	GL11.glColor3f(0, 0,1); //couleur
    	GL11.glVertex3f(size, -size, size); //avant droite
    	
    	GL11.glColor3f(1, 0, 1); //couleur
    	GL11.glVertex3f(-size, -size, size); //avant gauche
    	GL11.glColor3f(0, 0,1); //couleur
    	GL11.glVertex3f(size, -size, size); //avant droite
    	GL11.glColor3f(1, 0, 0); //couleur
    	GL11.glVertex3f(-size, -size, -size); //arriere gauche

    	
    	//face de droite
    	GL11.glNormal3f( 1.0f, 0.0f, 0.0f);     //Normale qui pointe a droite
    	GL11.glColor3f(1, 0, 0); //couleur
    	GL11.glVertex3f(size, -size, -size);//arriere bas
    	GL11.glColor3f(0, 1, 0); //couleur
    	GL11.glVertex3f(size, size, -size);//arriere haut
    	GL11.glColor3f(0, 0,1); //couleur
    	GL11.glVertex3f(size, size, size);//avant haut
    	
    	GL11.glColor3f(1, 0, 1); //couleur
    	GL11.glVertex3f(size, -size, size);//avant bas
    	GL11.glColor3f(1, 0, 0); //couleur
    	GL11.glVertex3f(size, -size, -size);//arriere bas
    	GL11.glColor3f(0, 0,1); //couleur
    	GL11.glVertex3f(size, size, size);//avant haut

    	
    	//face de gauche
    	GL11.glNormal3f(-1.0f, 0.0f, 0.0f);          //Normale qui pointe a gauche
    	GL11.glColor3f(1, 0, 0); //couleur
    	GL11.glVertex3f(-size, -size, -size);//arriere bas
    	GL11.glColor3f(0, 1, 0); //couleur
    	GL11.glVertex3f(-size, -size, size); //avant bas
    	GL11.glColor3f(0, 0,1); //couleur
    	GL11.glVertex3f(-size, size, size); //avant haut
    	
    	GL11.glColor3f(1, 0, 1); //couleur
    	GL11.glVertex3f(-size, size, -size); //arriere haut
    	GL11.glColor3f(1, 0, 0); //couleur
    	GL11.glVertex3f(-size, -size, -size);//arriere bas
    	GL11.glColor3f(0, 0,1); //couleur
    	GL11.glVertex3f(-size, size, size); //avant haut

    	GL11.glEnd();	
	}

@Deprecated
public static void cubeHereColorful(float xRot, float yRot, float zRot, float size){
		
		//rotation
    	GL11.glRotatef(xRot, 1.0f, 0.0f, 0.0f); //rotation en x
    	GL11.glRotatef(yRot, 0.0f, 1.0f, 0.0f); //rotation en y
    	GL11.glRotatef(zRot, 0.0f, 0.0f, 1.0f); //rotation en z
    	
    	//dessin du cube
    	GL11.glBegin(GL11.GL_QUADS);
    	//couleur
    	
    	//face de devant
    	GL11.glNormal3f( 0.0f, 0.0f, 1.0f);// Normale pointant vers le joueur
    	GL11.glColor3f(1, 0, 0); //couleur
    	GL11.glVertex3f(-size, -size, size);//vertex en bas a gauche
    	GL11.glColor3f(0, 1, 0); //couleur
    	GL11.glVertex3f(size, -size, size);//vertex en bas a droite
    	GL11.glColor3f(0, 0,1); //couleur
    	GL11.glVertex3f(size, size, size);//vertex en haut a droite
    	GL11.glColor3f(1, 0, 1); //couleur
    	GL11.glVertex3f(-size, size, size);//vertex en haut a gauche
    	//face arriere
    	GL11.glNormal3f( 0.0f, 0.0f,-1.0f);// Normale partant vers le fond
    	GL11.glColor3f(1, 0, 0); //couleur
    	GL11.glVertex3f(-size, -size, -size);//en bas a gauche
    	GL11.glColor3f(0, 1, 0); //couleur
    	GL11.glVertex3f(-size, size, -size);//en haut a gauche
    	GL11.glColor3f(0, 0,1); //couleur
    	GL11.glVertex3f(size, size, -size);//en haut a droite
    	GL11.glColor3f(1, 0, 1); //couleur
    	GL11.glVertex3f(size, -size, -size);//en bas a droite
    	
    	//face de dessus
    	GL11.glNormal3f( 0.0f, 1.0f, 0.0f);//Normale qui pointe en haut
    	GL11.glColor3f(1, 0, 0); //couleur
    	GL11.glVertex3f(-size, size, -size);//arriere gauche
    	GL11.glColor3f(0, 1, 0); //couleur
    	GL11.glVertex3f(-size, size, size);//avant gauche
    	GL11.glColor3f(0, 0,1); //couleur
    	GL11.glVertex3f(size, size, size); //avant droite
    	GL11.glColor3f(1, 0, 1); //couleur
    	GL11.glVertex3f(size, size, -size); // arriere droite
    	//face du bas
    	 GL11.glNormal3f( 0.0f,-1.0f, 0.0f); //Normale qui pointe en bas
    	 GL11.glColor3f(1, 0, 0); //couleur
    	GL11.glVertex3f(-size, -size, -size); //arriere gauche
    	GL11.glColor3f(0, 1, 0); //couleur
    	GL11.glVertex3f(size, -size, -size); //arriere droite
    	GL11.glColor3f(0, 0,1); //couleur
    	GL11.glVertex3f(size, -size, size); //avant droite
    	GL11.glColor3f(1, 0, 1); //couleur
    	GL11.glVertex3f(-size, -size, size); //avant gauche
    	//face de droite
    	GL11.glNormal3f( 1.0f, 0.0f, 0.0f);     //Normale qui pointe a droite
    	GL11.glColor3f(1, 0, 0); //couleur
    	GL11.glVertex3f(size, -size, -size);//arriere bas
    	GL11.glColor3f(0, 1, 0); //couleur
    	GL11.glVertex3f(size, size, -size);//arriere haut
    	GL11.glColor3f(0, 0,1); //couleur
    	GL11.glVertex3f(size, size, size);//avant haut
    	GL11.glColor3f(1, 0, 1); //couleur
    	GL11.glVertex3f(size, -size, size);//avant bas
    	//face de gauche
    	GL11.glNormal3f(-1.0f, 0.0f, 0.0f);          //Normale qui pointe a gauche
    	GL11.glColor3f(1, 0, 0); //couleur
    	GL11.glVertex3f(-size, -size, -size);//arriere bas
    	GL11.glColor3f(0, 1, 0); //couleur
    	GL11.glVertex3f(-size, -size, size); //avant bas
    	GL11.glColor3f(0, 0,1); //couleur
    	GL11.glVertex3f(-size, size, size); //avant haut
    	GL11.glColor3f(1, 0, 1); //couleur
    	GL11.glVertex3f(-size, size, -size); //arriere haut
    	GL11.glEnd();	
	}	
}
