package com.github.eldosa.nehe.tuto;

import org.lwjgl.opengl.GL11;
import org.newdawn.slick.opengl.Texture;


/**
 * @author Thongvan Alexis
 * date:    25-FEV-2013
 * 
 * Draw shapes 
 * 
 */

public class DrawingFunctionForNehe {
	

/**
 * dessine un cube, prend pour centre l'endroit ou le curseur 
 * de dessin est plac�	
 * 
 */
	public static void cubeHere(float xRot, float yRot, float zRot, float size, Texture texture){
	
		//rotation
    	GL11.glRotatef(xRot, 1.0f, 0.0f, 0.0f); //rotation en x
    	GL11.glRotatef(yRot, 0.0f, 1.0f, 0.0f); //rotation en y
    	GL11.glRotatef(zRot, 0.0f, 0.0f, 1.0f); //rotation en z
    	
    	//binding de la texture
    	texture.bind(); 
    	
    	//dessin du cube
    	GL11.glBegin(GL11.GL_QUADS);
    	//face de devant
    	GL11.glNormal3f( 0.0f, 0.0f, 1.0f);// Normale pointant vers le joueur
    	GL11.glTexCoord2f(0.0f, 0.0f);
    	GL11.glVertex3f(-size, -size, size);//vertex en bas a gauche
    	GL11.glTexCoord2f(1.0f, 0.0f);
    	GL11.glVertex3f(size, -size, size);//vertex en bas a droite
    	GL11.glTexCoord2f(1.0f, 1.0f);
    	GL11.glVertex3f(size, size, size);//vertex en haut a droite
    	GL11.glTexCoord2f(0.0f, 1.0f);
    	GL11.glVertex3f(-size, size, size);//vertex en haut a gauche
    	//face arriere
    	GL11.glNormal3f( 0.0f, 0.0f,-1.0f);// Normale partant vers le fond
    	GL11.glTexCoord2f(1.0f, 0.0f);
    	GL11.glVertex3f(-size, -size, -size); 
    	GL11.glTexCoord2f(1.0f, 1.0f);
    	GL11.glVertex3f(-size, size, -size);
    	GL11.glTexCoord2f(0.0f, 1.0f);
    	GL11.glVertex3f(size, size, -size);
    	GL11.glTexCoord2f(0.0f, 0.0f);
    	GL11.glVertex3f(size, -size, -size);
    	//face de dessus
    	GL11.glNormal3f( 0.0f, 1.0f, 0.0f);//N?ormale qui pointe en haut
    	GL11.glTexCoord2f(0.0f, 1.0f);
    	GL11.glVertex3f(-size, size, -size);
    	GL11.glTexCoord2f(0.0f, 0.0f);
    	GL11.glVertex3f(-size, size, size);
    	GL11.glTexCoord2f(1.0f, 0.0f);
    	GL11.glVertex3f(size, size, size); 
    	GL11.glTexCoord2f(1.0f, 1.0f);
    	GL11.glVertex3f(size, size, -size);
    	//face du bas
    	GL11.glNormal3f( 0.0f,-1.0f, 0.0f); //Normale qui pointe en bas
    	GL11.glTexCoord2f(1.0f, 1.0f);
    	GL11.glVertex3f(-size, -size, -size);
    	GL11.glTexCoord2f(0.0f, 1.0f);
    	GL11.glVertex3f(size, -size, -size);
    	GL11.glTexCoord2f(0.0f, 0.0f);
    	GL11.glVertex3f(size, -size, size);
    	GL11.glTexCoord2f(1.0f, 0.0f);
    	GL11.glVertex3f(-size, -size, size);
    	//face de droite
    	GL11.glNormal3f( 1.0f, 0.0f, 0.0f);     //Normale qui pointe a droite
    	GL11.glTexCoord2f(1.0f, 0.0f);
    	GL11.glVertex3f(size, -size, -size);
    	GL11.glTexCoord2f(1.0f, 1.0f);
    	GL11.glVertex3f(size, size, -size);
    	GL11.glTexCoord2f(0.0f, 1.0f);
    	GL11.glVertex3f(size, size, size);
    	GL11.glTexCoord2f(0.0f, 0.0f);
    	GL11.glVertex3f(size, -size, size);
    	//face de gauche
    	GL11.glTexCoord2f(0.0f, 0.0f);
    	GL11.glVertex3f(-size, -size, -size);
    	GL11.glTexCoord2f(1.0f, 0.0f);
    	GL11.glVertex3f(-size, -size, size);
    	GL11.glTexCoord2f(1.0f, 1.0f);
    	GL11.glVertex3f(-size, size, size);
    	GL11.glTexCoord2f(0.0f, 1.0f);
    	GL11.glVertex3f(-size, size, -size);
    	GL11.glEnd();
	}
	
	public static void cubeHere(float xRot, float yRot, float zRot, float size, float r, float v, float b){
		
		//rotation
    	GL11.glRotatef(xRot, 1.0f, 0.0f, 0.0f); //rotation en x
    	GL11.glRotatef(yRot, 0.0f, 1.0f, 0.0f); //rotation en y
    	GL11.glRotatef(zRot, 0.0f, 0.0f, 1.0f); //rotation en z
    	
    	//dessin du cube
    	GL11.glBegin(GL11.GL_QUADS);
    	//couleur
    	GL11.glColor3f(r, v, b); //violet
    	//face de devant
    	GL11.glNormal3f( 0.0f, 0.0f, 1.0f);// Normale pointant vers le joueur
    	GL11.glVertex3f(-size, -size, size);//vertex en bas a gauche
    	GL11.glVertex3f(size, -size, size);//vertex en bas a droite
    	GL11.glVertex3f(size, size, size);//vertex en haut a droite
    	GL11.glVertex3f(-size, size, size);//vertex en haut a gauche
    	//face arriere
    	GL11.glNormal3f( 0.0f, 0.0f,-1.0f);// Normale partant vers le fond
    	GL11.glVertex3f(-size, -size, -size); 
    	GL11.glVertex3f(-size, size, -size);
    	GL11.glVertex3f(size, size, -size);
    	GL11.glVertex3f(size, -size, -size);
    	//face de dessus
    	GL11.glNormal3f( 0.0f, 1.0f, 0.0f);//N?ormale qui pointe en haut
    	GL11.glVertex3f(-size, size, -size);
    	GL11.glVertex3f(-size, size, size);
    	GL11.glVertex3f(size, size, size); 
    	GL11.glVertex3f(size, size, -size);
    	//face du bas
    	 GL11.glNormal3f( 0.0f,-1.0f, 0.0f); //Normale qui pointe en bas
    	GL11.glVertex3f(-size, -size, -size);
    	GL11.glVertex3f(size, -size, -size);
    	GL11.glVertex3f(size, -size, size);
    	GL11.glVertex3f(-size, -size, size);
    	//face de droite
    	GL11.glNormal3f( 1.0f, 0.0f, 0.0f);     //Normale qui pointe a droite
    	GL11.glVertex3f(size, -size, -size);
    	GL11.glVertex3f(size, size, -size);
    	GL11.glVertex3f(size, size, size);
    	GL11.glVertex3f(size, -size, size);
    	//face de gauche
    	GL11.glNormal3f(-1.0f, 0.0f, 0.0f);          //Normale qui pointe a gauche
    	GL11.glVertex3f(-size, -size, -size);
    	GL11.glVertex3f(-size, -size, size);
    	GL11.glVertex3f(-size, size, size);
    	GL11.glVertex3f(-size, size, -size);
    	GL11.glEnd();	
	}
	
	public static void cubeSomewhere(float x, float y, float z, float xRot, float yRot, float zRot, float size, Texture texture){
		
		GL11.glTranslatef(x, y, z);
		cubeHere(xRot, yRot, zRot, size, texture );
	}
	
	public static void cubeSomewhere(float x, float y, float z, float xRot, float yRot, float zRot, float size, float r, float v, float b){
	
		GL11.glTranslatef(x, y, z);
		cubeHere(xRot, yRot, zRot, size, r, v, b);
	}
	
	public static void partialCubeSomewhere(float x, float y, float z, float xRot, float yRot, float zRot, float size, Texture[][] texture, boolean[] visibility, short type){
		
		GL11.glTranslatef(x, y, z);
		partialCubeHere(xRot, yRot, zRot, size, texture, visibility, type );
	}
	
	public static void partialCubeHere(float xRot, float yRot, float zRot, float size, Texture[][] texture, boolean[] visibility, short type){
		
		//rotation
		if(xRot!=0)
    	GL11.glRotatef(xRot, 1.0f, 0.0f, 0.0f); //rotation en x
		if(yRot!=0)
    	GL11.glRotatef(yRot, 0.0f, 1.0f, 0.0f); //rotation en y
		if(zRot!=0)
    	GL11.glRotatef(zRot, 0.0f, 0.0f, 1.0f); //rotation en z
    	
    	//binding de la texture
    	
    	
    	
    	//face de devant
    	if (visibility[3]){
    	texture[type][1].bind(); 
    	GL11.glBegin(GL11.GL_QUADS);
    	GL11.glNormal3f( 0.0f, 0.0f, 1.0f);// Normale pointant vers le joueur
    	GL11.glTexCoord2f(0.0f, 0.0f);
    	GL11.glVertex3f(-size, -size, size);//vertex en bas a gauche
    	GL11.glTexCoord2f(1.0f, 0.0f);
    	GL11.glVertex3f(size, -size, size);//vertex en bas a droite
    	GL11.glTexCoord2f(1.0f, 1.0f);
    	GL11.glVertex3f(size, size, size);//vertex en haut a droite
    	GL11.glTexCoord2f(0.0f, 1.0f);
    	GL11.glVertex3f(-size, size, size);//vertex en haut a gauche
    	GL11.glEnd();
    	}
    	//face arriere8
    	if (visibility[2]){
    	texture[type][1].bind(); 
    	GL11.glBegin(GL11.GL_QUADS);
    	GL11.glNormal3f( 0.0f, 0.0f,-1.0f);// Normale partant vers le fond
    	GL11.glTexCoord2f(1.0f, 0.0f);
    	GL11.glVertex3f(-size, -size, -size); 
    	GL11.glTexCoord2f(1.0f, 1.0f);
    	GL11.glVertex3f(-size, size, -size);
    	GL11.glTexCoord2f(0.0f, 1.0f);
    	GL11.glVertex3f(size, size, -size);
    	GL11.glTexCoord2f(0.0f, 0.0f);
    	GL11.glVertex3f(size, -size, -size);
    	GL11.glEnd();
    	}
    	//face de dessus
    	if (visibility[0]){
    	texture[type][0].bind(); 
    	GL11.glBegin(GL11.GL_QUADS);
    	GL11.glNormal3f( 0.0f, 1.0f, 0.0f);//N?ormale qui pointe en haut
    	GL11.glTexCoord2f(0.0f, 1.0f);
    	GL11.glVertex3f(-size, size, -size);
    	GL11.glTexCoord2f(0.0f, 0.0f);
    	GL11.glVertex3f(-size, size, size);
    	GL11.glTexCoord2f(1.0f, 0.0f);
    	GL11.glVertex3f(size, size, size); 
    	GL11.glTexCoord2f(1.0f, 1.0f);
    	GL11.glVertex3f(size, size, -size);
    	GL11.glEnd();
    	}
    	if (visibility[1]){
    	//face du bas
    	//System.out.println("type = "+type);
    	texture[type][2].bind(); 
    	GL11.glBegin(GL11.GL_QUADS);
    	GL11.glNormal3f( 0.0f,-1.0f, 0.0f); //Normale qui pointe en bas
    	GL11.glTexCoord2f(1.0f, 1.0f);
    	GL11.glVertex3f(-size, -size, -size);
    	GL11.glTexCoord2f(0.0f, 1.0f);
    	GL11.glVertex3f(size, -size, -size);
    	GL11.glTexCoord2f(0.0f, 0.0f);
    	GL11.glVertex3f(size, -size, size);
    	GL11.glTexCoord2f(1.0f, 0.0f);
    	GL11.glVertex3f(-size, -size, size);
    	GL11.glEnd();
    	}
    	//face de droite
    	if (visibility[5]){
    	texture[type][1].bind(); 
    	GL11.glBegin(GL11.GL_QUADS);
    	GL11.glNormal3f( 1.0f, 0.0f, 0.0f);     //Normale qui pointe a droite
    	GL11.glTexCoord2f(1.0f, 0.0f);
    	GL11.glVertex3f(size, -size, -size);
    	GL11.glTexCoord2f(1.0f, 1.0f);
    	GL11.glVertex3f(size, size, -size);
    	GL11.glTexCoord2f(0.0f, 1.0f);
    	GL11.glVertex3f(size, size, size);
    	GL11.glTexCoord2f(0.0f, 0.0f);
    	GL11.glVertex3f(size, -size, size);
    	GL11.glEnd();
    	}
    	//face de gauche
    	if (visibility[4]){
    	texture[type][1].bind(); 
    	GL11.glBegin(GL11.GL_QUADS);
    	GL11.glTexCoord2f(0.0f, 0.0f);
    	GL11.glVertex3f(-size, -size, -size);
    	GL11.glTexCoord2f(1.0f, 0.0f);
    	GL11.glVertex3f(-size, -size, size);
    	GL11.glTexCoord2f(1.0f, 1.0f);
    	GL11.glVertex3f(-size, size, size);
    	GL11.glTexCoord2f(0.0f, 1.0f);
    	GL11.glVertex3f(-size, size, -size);
    	GL11.glEnd();
    	}
    	
	}
}
