package com.github.eldosa.nehe.tuto;
/*
 *      This Code Was Created By Jeff Molofee 2000
 *      Modified by Shawn T. to handle (%3.2f, num) parameters.
 *      A HUGE Thanks To Fredric Echols For Cleaning Up
 *      And Optimizing The Base Code, Making It More Flexible!
 *      If You've Found This Code Useful, Please Let Me Know.
 *      Visit My Site At nehe.gamedev.net
 */
import org.lwjgl.input.Keyboard;
import org.lwjgl.opengl.Display;
import org.lwjgl.opengl.DisplayMode;
import org.lwjgl.opengl.GL11;
import org.lwjgl.util.glu.GLU;

/**
 * @author Mark Bernard
 * date:    26-May-2004
 *
 * Ported directly from the C++ version
 *
 * The main point of this tutorial is to get fonts on the screen.  The original OpenGL did
 * not port directly as it used Windows specific extensions and I could not get some OpenGL
 * commands to work.  In the end, what you see on the screen is the same, but it is written
 * somewhat differently.  I have noted the differences in the code with comments.
 *
 * 2004-10-08: Updated to version 0.92alpha of LWJGL.
 * 2004-12-19: Updated to version 0.94alpha of LWJGL
 */


/**
 * @author Thongvan Alexis
 * date:    25-FEV-2013
 * 
 * I don't take credit for anything, those tutorial are from nehe.
 * 
 * But it's 2013 and some stuff don't work anymore so I converted them
 * to lwgjl 2.8.5 and I'm using slick.opengl.TextureLoader instead of devil.IL to load texture
 * (since devil.IL does not exist anymore)
 * 
 * Plus if you get this from github it's in a nice maven project which will download
 * for you lwgjl and slick and package everything, plug and play baby.
 * 
 * this code is CPU-dependant, meaning : 
 * if you have a slow pc the animation will be slow
 * if you have the same pc than me the animation will run at normal speed
 * if you have a faster pc than me the animation will run faster
 * 
 * Video tutorial explaining how to set up maven, eclipse, etc : <Not available yet>
 */

public class Tut03 {
    
    private final String windowTitle = "Triangles color�";
    private DisplayMode displayMode;
    private boolean done = false;
    private boolean f = false;
    private boolean fullscreen = false;
 
    public static void main(String args[]) {
        Tut03 t3 = new Tut03();
        t3.run();
    }

    /**
     * Boucle principale
     */
    public void run() {
        try {
            init();
            while (!done) {
                readAndAct();
                render();
                Display.update();
            }
            Destroy();
        }
        catch (Exception e) {
            e.printStackTrace();
            System.exit(0);
        }
    }

    /**
     * Toute les updates sont fait ici, lecture de clavier, 
     * lecture de souris, agissement IA, etc
     */
    private void readAndAct() {
    	//quitte si echap est press�
        if(Keyboard.isKeyDown(Keyboard.KEY_ESCAPE)) {
            done = true;
        }
        //quitte si la croix est cliqu�
        if(Display.isCloseRequested()) {             
            done = true;
        }
        if(Keyboard.isKeyDown(Keyboard.KEY_F) && !f) {    
            f = true;                                   
            toggle();                                   
        }
        if(!Keyboard.isKeyDown(Keyboard.KEY_F)) {         
            f = false;
        }
    }
    
    private void toggle() {
        fullscreen = !fullscreen;
        try {
            Display.setFullscreen(fullscreen);
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }    
    
    
    

    /**
     * Ici tous les dessin sont fait a l'ecran
     * le "rendering"
     * @return boolean si tous c'est bien passer
     */
    private boolean render() {
    	//efface l'ecran et le buffer de profondeur
        GL11.glClear(GL11.GL_COLOR_BUFFER_BIT | GL11.GL_DEPTH_BUFFER_BIT);
        //reset la Modelview matrix actuelle
        GL11.glLoadIdentity();        
        
        GL11.glTranslatef(-1.5f,0.0f,-6.0f);//on met un triangle a gauche au fond
        GL11.glBegin(GL11.GL_TRIANGLES);   //on va dessiner un triangle
        GL11.glColor3f(1.0f, 0.0f, 0.0f);  //rouge
        GL11.glVertex3f( 0.0f, 1.0f, 0.0f);//sommet
        GL11.glColor3f(0.0f, 1.0f, 0.0f);  //vert
        GL11.glVertex3f(-1.0f,-1.0f, 0.0f);//gauche
        GL11.glColor3f(0.0f, 0.0f, 1.0f);  //bleue
        GL11.glVertex3f( 1.0f,-1.0f, 0.0f);//droite
        GL11.glEnd();                      // Fini   
        
        GL11.glTranslatef(3f,0.0f,0.0f);   //on met un triangle a droite
        GL11.glBegin(GL11.GL_TRIANGLES);   //on va dessiner un triangle
        GL11.glColor3f( 1.0f, 0.0f, 1.0f); //violet
        GL11.glVertex3f( 0.0f, 1.0f, 0.0f);       
        GL11.glVertex3f(-1.0f,-1.0f, 0.0f);       
        GL11.glVertex3f( 1.0f,-1.0f, 0.0f);
        GL11.glEnd();                      // Fini   
                              
        return true;
    }

    /**
     * Cr�e la fenetre
     * @throws Exception Throws Window.create() exception.
     */
    private void createWindow() throws Exception {
    	//demande tous les mode d'affichage disponible
        DisplayMode d[] = Display.getAvailableDisplayModes();
        //parcour tous les mode retourn� et selectionne celui ou
        //hauteur = 480, largeur = 640, et ou on a 32 bits par pixel
        for (int i = 0; i < d.length; i++) {
            if (d[i].getWidth() == 640
                && d[i].getHeight() == 480
                && d[i].getBitsPerPixel() == 32) {
                displayMode = d[i];
                break;
            }
        }
        Display.setDisplayMode(displayMode);
        Display.setTitle(windowTitle);
        Display.create();
    }

    /**
     * Faire toute les initialisation ici, comme le clavier et openGL
     */
    private void init() throws Exception {
        createWindow();
        initGL();
    }

    /**
     * Init OpenGL
     *
     */
    private void initGL() {
    	
        GL11.glEnable(GL11.GL_TEXTURE_2D);//texture mapping 
        GL11.glShadeModel(GL11.GL_SMOOTH);//smooth shading 
        GL11.glClearColor(0.0f, 0.0f, 0.0f, 0.0f);//couleur de fond noire
        GL11.glClearDepth(1.0);//setup du buffer de profondeur 
        GL11.glEnable(GL11.GL_DEPTH_TEST);//permet le test de profondeur 
        GL11.glDepthFunc(GL11.GL_LEQUAL); //le type de test de profondeur a faire
        GL11.glMatrixMode(GL11.GL_PROJECTION);//selectrione la matrice de projection    
        GL11.glLoadIdentity();//reset la matrice de projection
        // Calcul l'aspect ratio de la fenetre
        GLU.gluPerspective(
          45.0f,
          (float) displayMode.getWidth() / (float) displayMode.getHeight(),
          0.1f,
          100.0f);
          
          GL11.glMatrixMode(GL11.GL_MODELVIEW);//selectionne la modelview Matrix
          // met les melleur parametre
          GL11.glHint(GL11.GL_PERSPECTIVE_CORRECTION_HINT, GL11.GL_NICEST);
    }

    /**
     * nettoyage.
     */
    private void Destroy() {
        Display.destroy();
    }

}
