package com.github.eldosa.nehe.tuto;
/*
 *      This Code Was Created By Jeff Molofee 2000
 *      Modified by Shawn T. to handle (%3.2f, num) parameters.
 *      A HUGE Thanks To Fredric Echols For Cleaning Up
 *      And Optimizing The Base Code, Making It More Flexible!
 *      If You've Found This Code Useful, Please Let Me Know.
 *      Visit My Site At nehe.gamedev.net
 */
import java.io.IOException;

import org.lwjgl.input.Keyboard;
import org.lwjgl.opengl.Display;
import org.lwjgl.opengl.DisplayMode;
import org.lwjgl.opengl.GL11;
import org.lwjgl.util.glu.GLU;
import org.newdawn.slick.opengl.Texture;
import org.newdawn.slick.opengl.TextureLoader;
import org.newdawn.slick.util.ResourceLoader;

/**
 * @author Mark Bernard
 * date:    26-May-2004
 *
 * Ported directly from the C++ version
 *
 * The main point of this tutorial is to get fonts on the screen.  The original OpenGL did
 * not port directly as it used Windows specific extensions and I could not get some OpenGL
 * commands to work.  In the end, what you see on the screen is the same, but it is written
 * somewhat differently.  I have noted the differences in the code with comments.
 *
 * 2004-10-08: Updated to version 0.92alpha of LWJGL.
 * 2004-12-19: Updated to version 0.94alpha of LWJGL
 */


/**
 * @author Thongvan Alexis
 * date:    25-FEV-2013
 * 
 * I don't take credit for anything, those tutorial are from nehe.
 * 
 * But it's 2013 and some stuff don't work anymore so I converted them
 * to lwgjl 2.8.5 and I'm using slick.opengl.TextureLoader instead of devil.IL to load texture
 * (since devil.IL does not exist anymore)
 * 
 * Plus if you get this from github it's in a nice maven project which will download
 * for you lwgjl and slick and package everything, plug and play baby.
 * 
 * this code is CPU-dependant, meaning : 
 * if you have a slow pc the animation will be slow
 * if you have the same pc than me the animation will run at normal speed
 * if you have a faster pc than me the animation will run faster
 * 
 * Video tutorial explaining how to set up maven, eclipse, etc : <Not available yet>
 */

public class Tut09 {
 
	private final String windowTitle = "Bitmap qui bouge dans l'espace";
	private boolean done = false;
	private boolean fullscreen = false;

	//les touche utilis� qui doivent etre lu une seule fois lorsque press�
	private boolean F,B;
	private DisplayMode displayMode;
	
	private boolean brillance; //brillance ON/OFF
	private final int num = 50; // Nombre d'etoiles simultan�e
	private Stars star[] = new Stars[num]; // stockage des etoiles
	private float dist = -20.0f; // distance entre ecran et etoile
	private float angle = 90.0f; // angle de la galaxy
	private float spin; // Spin Stars
	private Texture starText;// texture de l'etoile, le bmp                        
    
    public static void main(String args[]) {
        Tut09 t9 = new Tut09();
        t9.run();
    }

    /**
     * Init OpenGL
     *
     */
    private void initGL() {
    	
        GL11.glEnable(GL11.GL_TEXTURE_2D);//texture mapping 
        GL11.glShadeModel(GL11.GL_SMOOTH);//smooth shading 
        GL11.glClearColor(0.0f, 0.0f, 0.0f, 0.0f);//couleur de fond noire
        //GL11.glClearDepth(1.0);//setup du buffer de profondeur 
        //GL11.glEnable(GL11.GL_DEPTH_TEST);//permet le test de profondeur 
        //GL11.glDepthFunc(GL11.GL_LEQUAL); //le type de test de profondeur a faire
        GL11.glMatrixMode(GL11.GL_PROJECTION);//selectrione la matrice de projection    
        GL11.glLoadIdentity();//reset la matrice de projection
        // Calcul l'aspect ratio de la fenetre
        GLU.gluPerspective(
          45.0f,
          (float) displayMode.getWidth() / (float) displayMode.getHeight(),
          0.1f,
          100.0f);
          
          GL11.glMatrixMode(GL11.GL_MODELVIEW);//selectionne la modelview Matrix
          
          
          GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE); // rend notre etoile brillante
          GL11.glEnable(GL11.GL_BLEND);
          
          // met les melleur parametre
          GL11.glHint(GL11.GL_PERSPECTIVE_CORRECTION_HINT, GL11.GL_NICEST);
    }    
    
    /**
     * Boucle principale
     */
    public void run() {
        try {
            init();
            while (!done) {
                readAndAct();
                render();
                Display.update();
            }
            Destroy();
        }
        catch (Exception e) {
            e.printStackTrace();
            System.exit(0);
        }
    }

    /**
     * Toute les updates sont fait ici, lecture de clavier, 
     * lecture de souris, agissement IA, etc
     */
    private void readAndAct() {
        if(Keyboard.isKeyDown(Keyboard.KEY_ESCAPE)) {       
            done = true;
        }
        if(Display.isCloseRequested()) {                 
            done = true;
        }
        if(Keyboard.isKeyDown(Keyboard.KEY_F) && !F) {    
            F = true;                                 
            toggle();                                  
        }
        if(!Keyboard.isKeyDown(Keyboard.KEY_F)) {          
            F = false;
        }
        if (Keyboard.isKeyDown(Keyboard.KEY_B) && !B) {
            B = true;
            brillance = !brillance;
        }
        else if (!Keyboard.isKeyDown(Keyboard.KEY_B)) {
            B = false;
        }
        if (Keyboard.isKeyDown(Keyboard.KEY_PRIOR)) { 
            dist -= 0.02f; 
        }
        if (Keyboard.isKeyDown(Keyboard.KEY_NEXT)) {
            dist += 0.02f; 
        }
        if (Keyboard.isKeyDown(Keyboard.KEY_UP)) { 
            angle -= 0.1f; 
        }
        if (Keyboard.isKeyDown(Keyboard.KEY_DOWN)) { 
            angle += 0.1f; 
        }
    	
    }
    
    private void toggle() {
        fullscreen = !fullscreen;
        try {
            Display.setFullscreen(fullscreen);
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }    
    
    
    

    /**
     * Ici tous les dessin sont fait a l'ecran
     * le "rendering"
     * @return boolean si tous c'est bien passer
     */
    private boolean render() {
        GL11.glClear(GL11.GL_COLOR_BUFFER_BIT | GL11.GL_DEPTH_BUFFER_BIT); // Clear The Screen And The Depth Buffer
        starText.bind(); // Select Our Texture

        for (int i = 0; i < num; i++) // Loop Through All The Stars
            {
            GL11.glLoadIdentity(); // Reset The View Before We Draw Each Star
            GL11.glTranslatef(0.0f, 0.0f, dist); // Zoom Into The Screen (Using The Value In 'zoom')
            GL11.glRotatef(angle, 1.0f, 0.0f, 0.0f); // Tilt The View (Using The Value In 'tilt')
            GL11.glRotatef(star[i].angle, 0.0f, 1.0f, 0.0f); // Rotate To The Current Stars Angle
            GL11.glTranslatef(star[i].dist, 0.0f, 0.0f); // Move Forward On The X Plane
            GL11.glRotatef(-star[i].angle, 0.0f, 1.0f, 0.0f); // Cancel The Current Stars Angle
            GL11.glRotatef(-angle, 1.0f, 0.0f, 0.0f); // Cancel The Screen Tilt

            if (brillance) {
                GL11.glColor4ub(star[(num - i) - 1].r, star[(num - i) - 1].g, star[(num - i) - 1].b, (byte) 255);
                GL11.glBegin(GL11.GL_QUADS);
                GL11.glTexCoord2f(0.0f, 0.0f);
                GL11.glVertex3f(-1.0f, -1.0f, 0.0f);
                GL11.glTexCoord2f(1.0f, 0.0f);
                GL11.glVertex3f(1.0f, -1.0f, 0.0f);
                GL11.glTexCoord2f(1.0f, 1.0f);
                GL11.glVertex3f(1.0f, 1.0f, 0.0f);
                GL11.glTexCoord2f(0.0f, 1.0f);
                GL11.glVertex3f(-1.0f, 1.0f, 0.0f);
                GL11.glEnd();
            }

            GL11.glRotatef(spin, 0.0f, 0.0f, 1.0f);
            GL11.glColor4ub(star[i].r, star[i].g, star[i].b, (byte) 255);
            GL11.glBegin(GL11.GL_QUADS);
            GL11.glTexCoord2f(0.0f, 0.0f);
            GL11.glVertex3f(-1.0f, -1.0f, 0.0f);
            GL11.glTexCoord2f(1.0f, 0.0f);
            GL11.glVertex3f(1.0f, -1.0f, 0.0f);
            GL11.glTexCoord2f(1.0f, 1.0f);
            GL11.glVertex3f(1.0f, 1.0f, 0.0f);
            GL11.glTexCoord2f(0.0f, 1.0f);
            GL11.glVertex3f(-1.0f, 1.0f, 0.0f);
            GL11.glEnd();

            spin += 0.01f;
            star[i].angle += (float) i / (float) num;
            star[i].dist -= 0.01f;
            if (star[i].dist < 0.0f) {
                star[i].dist += 5.0f;
                star[i].r = (byte) (Math.random() * 256.0);
                star[i].g = (byte) (Math.random() * 256.0);
                star[i].b = (byte) (Math.random() * 256.0);
            }
        }
        return true;
    }

    /**
     * Cr�e la fenetre
     * @throws Exception Throws Window.create() exception.
     */
    private void createWindow() throws Exception {
    	//demande tous les mode d'affichage disponible
        DisplayMode d[] = Display.getAvailableDisplayModes();
        //parcour tous les mode retourn� et selectionne celui ou
        //hauteur = 480, largeur = 640, et ou on a 32 bits par pixel
        for (int i = 0; i < d.length; i++) {
            if (d[i].getWidth() == 640
                && d[i].getHeight() == 480
                && d[i].getBitsPerPixel() == 32) {
                displayMode = d[i];
                break;
            }
        }
        Display.setDisplayMode(displayMode);
        Display.setTitle(windowTitle);
        Display.create();
    }

    /**
     * Faire toute les initialisation ici, comme le clavier et openGL
     */
    private void init() throws Exception {
        createWindow();
        loadTextures();
        initGL();
        initStarArray();
        
    }
    
    private void initStarArray(){
    	for (int i = 0; i < num; i++) {
            star[i] = new Stars();
            star[i].angle = 0.0f;
            star[i].dist = ((float) i / (float) num) * 5.0f;
            star[i].r = (byte) (Math.random() * 256.0);
            star[i].g = (byte) (Math.random() * 256.0);
            star[i].b = (byte) (Math.random() * 256.0);
        }
    }
    
    private void loadTextures() throws IOException {
    	starText = TextureLoader.getTexture("BMP", ResourceLoader.getResourceAsStream("src/textures/Star.bmp"));
    }

    /**
     * nettoyage.
     */
    private void Destroy() {
        Display.destroy();
    }

}



class Stars {
    public byte r, g, b; //couleur de l'etoile
    public float dist;   //Distance a partir du centre
    public float angle;  //Angle
}
