package com.github.eldosa.nehe.tuto;
/*
 *      This Code Was Created By Jeff Molofee 2000
 *      Modified by Shawn T. to handle (%3.2f, num) parameters.
 *      A HUGE Thanks To Fredric Echols For Cleaning Up
 *      And Optimizing The Base Code, Making It More Flexible!
 *      If You've Found This Code Useful, Please Let Me Know.
 *      Visit My Site At nehe.gamedev.net
 */
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.StringTokenizer;

import org.lwjgl.input.Keyboard;
import org.lwjgl.opengl.Display;
import org.lwjgl.opengl.DisplayMode;
import org.lwjgl.opengl.GL11;
import org.lwjgl.util.glu.GLU;
import org.newdawn.slick.opengl.Texture;
import org.newdawn.slick.opengl.TextureLoader;
import org.newdawn.slick.util.ResourceLoader;

/**
 * @author Mark Bernard
 * date:    26-May-2004
 *
 * Ported directly from the C++ version
 *
 * The main point of this tutorial is to get fonts on the screen.  The original OpenGL did
 * not port directly as it used Windows specific extensions and I could not get some OpenGL
 * commands to work.  In the end, what you see on the screen is the same, but it is written
 * somewhat differently.  I have noted the differences in the code with comments.
 *
 * 2004-10-08: Updated to version 0.92alpha of LWJGL.
 * 2004-12-19: Updated to version 0.94alpha of LWJGL
 */


/**
 * @author Thongvan Alexis
 * date:    25-FEV-2013
 * 
 * I don't take credit for anything, those tutorial are from nehe.
 * 
 * But it's 2013 and some stuff don't work anymore so I converted them
 * to lwgjl 2.8.5 and I'm using slick.opengl.TextureLoader instead of devil.IL to load texture
 * (since devil.IL does not exist anymore)
 * 
 * Plus if you get this from github it's in a nice maven project which will download
 * for you lwgjl and slick and package everything, plug and play baby.
 * 
 * this code is CPU-dependant, meaning : 
 * if you have a slow pc the animation will be slow
 * if you have the same pc than me the animation will run at normal speed
 * if you have a faster pc than me the animation will run faster
 * 
 * Video tutorial explaining how to set up maven, eclipse, etc : <Not available yet>
 */

public class Tut10 {
    
    private final String windowTitle = "Generation de monde 3D a partir de fichier";
    private DisplayMode displayMode;
    private boolean done = false;
    private boolean F, B, N;
    private boolean fullscreen = false;
    
    private int textureNo;                                         
    private Texture texture[] = new Texture[3];                       
    private boolean blend; 
    
    private final float piover180 = 0.0174532925f;
    private float heading;
    private float xpos;
    private float zpos;
    private float yrot;                 // Y Rotation
    private float walkbias = 0;
    private float walkbiasangle = 0;
    private float lookupdown = 0.0f;
    private float z;
    private Sector sector1;
    public static void main(String args[]) {
        Tut10 t10 = new Tut10();
        t10.run();
    }

    /**
     * Init OpenGL
     *
     */
    private void initGL() {
    	
        GL11.glEnable(GL11.GL_TEXTURE_2D);//texture mapping 
        GL11.glShadeModel(GL11.GL_SMOOTH);//smooth shading 
        GL11.glClearColor(0.0f, 0.0f, 0.0f, 0.0f);//couleur de fond noire
        GL11.glClearDepth(1.0);//setup du buffer de profondeur 
        GL11.glEnable(GL11.GL_DEPTH_TEST);//permet le test de profondeur 
        GL11.glDepthFunc(GL11.GL_LEQUAL); //le type de test de profondeur a faire
        GL11.glMatrixMode(GL11.GL_PROJECTION);//selectrione la matrice de projection    
        GL11.glLoadIdentity();//reset la matrice de projection
        // Calcul l'aspect ratio de la fenetre
        GLU.gluPerspective(
          45.0f,
          (float) displayMode.getWidth() / (float) displayMode.getHeight(),
          0.1f,
          100.0f);
          
          GL11.glMatrixMode(GL11.GL_MODELVIEW);//selectionne la modelview Matrix
          
          
          GL11.glColor4f(1.0f,1.0f,1.0f,0.3f);              // Full luminosit�, 30% Alpha
          GL11.glBlendFunc(GL11.GL_SRC_ALPHA,GL11.GL_ONE);      // Blending mode one
          
          // met les melleur parametre
          GL11.glHint(GL11.GL_PERSPECTIVE_CORRECTION_HINT, GL11.GL_NICEST);
    }    
    
    /**
     * Boucle principale
     */
    public void run() {
        try {
            init();
            while (!done) {
                readAndAct();
                render();
                Display.update();
            }
            Destroy();
        }
        catch (Exception e) {
            e.printStackTrace();
            System.exit(0);
        }
    }

    /**
     * Toute les updates sont fait ici, lecture de clavier, 
     * lecture de souris, agissement IA, etc
     */
    private void readAndAct() {
        if(Keyboard.isKeyDown(Keyboard.KEY_ESCAPE)) {       // Exit if Escape is pressed
            done = true;
        }
        if(Display.isCloseRequested()) {                     // Exit if window is closed
            done = true;
        }
        if(Keyboard.isKeyDown(Keyboard.KEY_F) && !F) {    // Is F1 Being Pressed?
            F = true;                                      // Tell Program F1 Is Being Held
            toggle();                                   // Toggle Fullscreen / Windowed Mode
        }
        if(!Keyboard.isKeyDown(Keyboard.KEY_F)) {          // Is F1 Being Pressed?
            F = false;
        }
        if (Keyboard.isKeyDown(Keyboard.KEY_B) && !B) {
            B = true;
            blend = !blend;
            if (!blend) {
                GL11.glDisable(GL11.GL_BLEND);
                GL11.glEnable(GL11.GL_DEPTH_TEST);
            }
            else {
                GL11.glEnable(GL11.GL_BLEND);
                GL11.glDisable(GL11.GL_DEPTH_TEST);
            }
        }
        if (!Keyboard.isKeyDown(Keyboard.KEY_B)) {
            B = false;
        }

        if (Keyboard.isKeyDown(Keyboard.KEY_N) && !N) {
            N = true;
            textureNo += 1;
            if (textureNo > 2) {
                textureNo = 0;
            }
        }
        if (!Keyboard.isKeyDown(Keyboard.KEY_N)) {
            N = false;
        }

        if (Keyboard.isKeyDown(Keyboard.KEY_PRIOR)) {
            z -= 0.002f;
        }

        if (Keyboard.isKeyDown(Keyboard.KEY_NEXT)) {
            z += 0.002f;
        }

        if (Keyboard.isKeyDown(Keyboard.KEY_UP)) {

            xpos -= (float) Math.sin(heading * piover180) * 0.0005f;
            zpos -= (float) Math.cos(heading * piover180) * 0.0005f;
            if (walkbiasangle >= 359.0f) {
                walkbiasangle = 0.0f;
            }
            else {
                walkbiasangle += 10;
            }
            walkbias = (float) Math.sin(walkbiasangle * piover180) / 20.0f;
        }

        if (Keyboard.isKeyDown(Keyboard.KEY_DOWN)) {
            xpos += (float) Math.sin(heading * piover180) * 0.0005f;
            zpos += (float) Math.cos(heading * piover180) * 0.0005f;
            if (walkbiasangle <= 1.0f) {
                walkbiasangle = 359.0f;
            }
            else {
                walkbiasangle -= 10;
            }
            walkbias = (float) Math.sin(walkbiasangle * piover180) / 20.0f;
        }

        if (Keyboard.isKeyDown(Keyboard.KEY_RIGHT)) {
            heading -= 0.1f;
            yrot = heading;
        }

        if (Keyboard.isKeyDown(Keyboard.KEY_LEFT)) {
            heading += 0.1f;
            yrot = heading;
        }

        if (Keyboard.isKeyDown(Keyboard.KEY_PRIOR)) {
            lookupdown -= 0.1f;
        }

        if (Keyboard.isKeyDown(Keyboard.KEY_NEXT)) {
            lookupdown += 0.1f;
        } 

    }
    
    private void toggle() {
        fullscreen = !fullscreen;
        try {
            Display.setFullscreen(fullscreen);
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }    
    
    
    

    /**
     * Ici tous les dessin sont fait a l'ecran
     * le "rendering"
     * @return boolean si tous c'est bien passer
     */
    private boolean render() {
        GL11.glClear(GL11.GL_COLOR_BUFFER_BIT | GL11.GL_DEPTH_BUFFER_BIT);  // Clear The Screen And The Depth Buffer
        GL11.glLoadIdentity();                                  // Reset The View

        float x_m, y_m, z_m, u_m, v_m;
        float xtrans = -xpos;
        float ztrans = -zpos;
        float ytrans = -walkbias-0.25f;
        float sceneroty = 360.0f - yrot;

        int numTriangles;

        GL11.glRotatef(lookupdown,1.0f,0,0);
        GL11.glRotatef(sceneroty,0,1.0f,0);

        GL11.glTranslatef(xtrans, ytrans, ztrans);
        texture[textureNo].bind();

        numTriangles = sector1.numTriangles;

        // Process Each Triangle
        for (int loop_m = 0; loop_m < numTriangles; loop_m++)
        {
            GL11.glBegin(GL11.GL_TRIANGLES);
                GL11.glNormal3f( 0.0f, 0.0f, 1.0f);
                x_m = sector1.triangle[loop_m].vertex[0].x;
                y_m = sector1.triangle[loop_m].vertex[0].y;
                z_m = sector1.triangle[loop_m].vertex[0].z;
                u_m = sector1.triangle[loop_m].vertex[0].u;
                v_m = sector1.triangle[loop_m].vertex[0].v;
                GL11.glTexCoord2f(u_m,v_m); GL11.glVertex3f(x_m,y_m,z_m);

                x_m = sector1.triangle[loop_m].vertex[1].x;
                y_m = sector1.triangle[loop_m].vertex[1].y;
                z_m = sector1.triangle[loop_m].vertex[1].z;
                u_m = sector1.triangle[loop_m].vertex[1].u;
                v_m = sector1.triangle[loop_m].vertex[1].v;
                GL11.glTexCoord2f(u_m,v_m); GL11.glVertex3f(x_m,y_m,z_m);

                x_m = sector1.triangle[loop_m].vertex[2].x;
                y_m = sector1.triangle[loop_m].vertex[2].y;
                z_m = sector1.triangle[loop_m].vertex[2].z;
                u_m = sector1.triangle[loop_m].vertex[2].u;
                v_m = sector1.triangle[loop_m].vertex[2].v;
                GL11.glTexCoord2f(u_m,v_m); GL11.glVertex3f(x_m,y_m,z_m);
            GL11.glEnd();
        }
        return true;
    }

    /**
     * Cr�e la fenetre
     * @throws Exception Throws Window.create() exception.
     */
    private void createWindow() throws Exception {
    	//demande tous les mode d'affichage disponible
        DisplayMode d[] = Display.getAvailableDisplayModes();
        //parcour tous les mode retourn� et selectionne celui ou
        //hauteur = 480, largeur = 640, et ou on a 32 bits par pixel
        for (int i = 0; i < d.length; i++) {
            if (d[i].getWidth() == 640
                && d[i].getHeight() == 480
                && d[i].getBitsPerPixel() == 32) {
                displayMode = d[i];
                break;
            }
        }
        Display.setDisplayMode(displayMode);
        Display.setTitle(windowTitle);
        Display.create();
    }

    /**
     * Faire toute les initialisation ici, comme le clavier et openGL
     */
    private void init() throws Exception {
        createWindow();
        loadTextures();
        setupWorld();
        initGL();
    }
    
    private void loadTextures() throws IOException {
    	texture[0] = TextureLoader.getTexture("JPG", ResourceLoader.getResourceAsStream("src/textures/tut8tex.jpg"));
    	texture[1] = TextureLoader.getTexture("JPG", ResourceLoader.getResourceAsStream("src/textures/tut8tex2.jpg"));
    	texture[2] = TextureLoader.getTexture("JPG", ResourceLoader.getResourceAsStream("src/textures/tut8tex1.jpg"));
    }

    /**
     * nettoyage.
     */
    private void Destroy() {
        Display.destroy();
    }
    
    
    private final void setupWorld() {

        try {
            String line;
            BufferedReader dis = new BufferedReader(new FileReader("src/textures/World.txt"));

            while ((line = dis.readLine()) != null) {
                if (line.trim().length() == 0 || line.trim().startsWith("//"))
                    continue;

                if (line.startsWith("NUMPOLLIES")) {
                    int numTriangles;

                    numTriangles = Integer.parseInt(line.substring(line.indexOf("NUMPOLLIES") + "NUMPOLLIES".length() + 1));
                    sector1 = new Sector(numTriangles);

                    break;
                }
            }

            for (int i = 0; i < sector1.numTriangles; i++) {
                for (int vert = 0; vert < 3; vert++) {

                    while ((line = dis.readLine()) != null) {
                        if (line.trim().length() == 0 || line.trim().startsWith("//"))
                            continue;

                        break;
                    }

                    if (line != null) {
                        StringTokenizer st = new StringTokenizer(line, " ");

                        sector1.triangle[i].vertex[vert].x = Float.valueOf(st.nextToken()).floatValue();
                        sector1.triangle[i].vertex[vert].y = Float.valueOf(st.nextToken()).floatValue();
                        sector1.triangle[i].vertex[vert].z = Float.valueOf(st.nextToken()).floatValue();
                        sector1.triangle[i].vertex[vert].u = Float.valueOf(st.nextToken()).floatValue();
                        sector1.triangle[i].vertex[vert].v = Float.valueOf(st.nextToken()).floatValue();
                    }
                }
            }

            dis.close();

        }
        catch (IOException ioe) {
            ioe.printStackTrace();
        }
    }

}


class Vertex {
    public float x, y, z;
    public float u, v;
}

class Triangle {
    public Vertex vertex[];

    public Triangle() {
        vertex=new Vertex[3];
        for(int i=0;i<3;i++) {
            vertex[i]=new Vertex();
        }
    }
}

class Sector {
    public int numTriangles;
    Triangle triangle[]; //holds class Triangle objects
    public Sector(int num) {
        numTriangles=num;
        triangle=new Triangle[numTriangles];
        for(int i=0;i<numTriangles;i++) {
            triangle[i]=new Triangle();
        }
    }
}

