package com.github.eldosa.nehe.tuto;
/*
 *      This Code Was Created By Jeff Molofee 2000
 *      Modified by Shawn T. to handle (%3.2f, num) parameters.
 *      A HUGE Thanks To Fredric Echols For Cleaning Up
 *      And Optimizing The Base Code, Making It More Flexible!
 *      If You've Found This Code Useful, Please Let Me Know.
 *      Visit My Site At nehe.gamedev.net
 */
import java.io.IOException;


import org.lwjgl.input.Keyboard;
import org.lwjgl.opengl.Display;
import org.lwjgl.opengl.DisplayMode;
import org.lwjgl.opengl.GL11;
import org.lwjgl.util.glu.GLU;
import org.newdawn.slick.opengl.Texture;
import org.newdawn.slick.opengl.TextureLoader;
import org.newdawn.slick.util.ResourceLoader;

/**
 * @author Mark Bernard
 * date:    26-May-2004
 *
 * The main point of this tutorial is to get fonts on the screen.  The original OpenGL did
 * not port directly as it used Windows specific extensions and I could not get some OpenGL
 * commands to work.  In the end, what you see on the screen is the same, but it is written
 * somewhat differently.  I have noted the differences in the code with comments.
 *
 * 2004-10-08: Updated to version 0.92alpha of LWJGL.
 * 2004-12-19: Updated to version 0.94alpha of LWJGL
 */


/**
 * @author Thongvan Alexis
 * date:    25-FEV-2013
 * 
 * I don't take credit for anything, those tutorial are from nehe.
 * 
 * But it's 2013 and some stuff don't work anymore so I converted them
 * to lwgjl 2.8.5 and I'm using slick.opengl.TextureLoader instead of devil.IL to load texture
 * (since devil.IL does not exist anymore)
 * 
 * Plus if you get this from github it's in a nice maven project which will download
 * for you lwgjl and slick and package everything, plug and play baby.
 * 
 * this code is CPU-dependant, meaning : 
 * if you have a slow pc the animation will be slow
 * if you have the same pc than me the animation will run at normal speed
 * if you have a faster pc than me the animation will run faster
 * 
 * Video tutorial explaining how to set up maven, eclipse, etc : <Not available yet>
 */

public class Tut11 {
    
    private boolean done = false;
    private boolean fullscreen = false;
    private final String windowTitle = "NeHe's Lesson 11 (Flag Effect (Waving Texture))";
    private boolean F = false;
    private DisplayMode displayMode;

    private float points[][][] = new float[45][45][3];    // The Array For The Points On The Grid Of Our "Wave"
    private int wiggle_count = 0;       // Counter Used To Control How Fast Flag Waves

    private float xrot;             // X Rotation ( NEW )
    private float yrot;             // Y Rotation ( NEW )
    private float zrot;             // Z Rotation ( NEW )
    private float hold;             // Temporarily Holds A Floating Point Value

    private Texture texture; // Storage For 1 Textures                                    
    
    public static void main(String args[]) {
        Tut11 t11 = new Tut11();
        t11.run();
    }

    /**
     * Init OpenGL
     *
     */
    private void initGL() {
    	
        GL11.glEnable(GL11.GL_TEXTURE_2D);//texture mapping 
        GL11.glShadeModel(GL11.GL_SMOOTH);//smooth shading 
        GL11.glClearColor(0.0f, 0.0f, 0.0f, 0.0f);//couleur de fond noire
        GL11.glClearDepth(1.0);//setup du buffer de profondeur 
        GL11.glEnable(GL11.GL_DEPTH_TEST);//permet le test de profondeur 
        GL11.glDepthFunc(GL11.GL_LEQUAL); //le type de test de profondeur a faire
        GL11.glMatrixMode(GL11.GL_PROJECTION);//selectrione la matrice de projection    
        GL11.glLoadIdentity();//reset la matrice de projection
        // Calcul l'aspect ratio de la fenetre
        GLU.gluPerspective(
          45.0f,
          (float) displayMode.getWidth() / (float) displayMode.getHeight(),
          0.1f,
          100.0f);
          
          GL11.glMatrixMode(GL11.GL_MODELVIEW);//selectionne la modelview Matrix
          
          
          GL11.glColor4f(1.0f,1.0f,1.0f,0.3f);              // Full luminosit�, 30% Alpha
          GL11.glBlendFunc(GL11.GL_SRC_ALPHA,GL11.GL_ONE);      // Blending mode one
          
          // met les melleur parametre
          GL11.glHint(GL11.GL_PERSPECTIVE_CORRECTION_HINT, GL11.GL_NICEST);
          
          GL11.glPolygonMode( GL11.GL_BACK, GL11.GL_FILL );                   // Back Face Is Solid
          GL11.glPolygonMode( GL11.GL_FRONT, GL11.GL_LINE );                  // Front Face Is Made Of Lines
    
    }    
    
    /**
     * Boucle principale
     */
    public void run() {
        try {
            init();
            while (!done) {
                readAndAct();
                render();
                Display.update();
                Thread.sleep(7);
            }
            Destroy();
        }
        catch (Exception e) {
            e.printStackTrace();
            System.exit(0);
        }
    }

    /**
     * Toute les updates sont fait ici, lecture de clavier, 
     * lecture de souris, agissement IA, etc
     */
    private void readAndAct() {
    	if(Keyboard.isKeyDown(Keyboard.KEY_ESCAPE)) {       
            done = true;
        }
        if(Display.isCloseRequested()) {                  
            done = true;
        }
        if(Keyboard.isKeyDown(Keyboard.KEY_F) && !F) {    
            F = true;                                    
            toggle();                                  
        }
        if(!Keyboard.isKeyDown(Keyboard.KEY_F)) {       
            F = false;
        }
 
    }
    
    private void toggle() {
        fullscreen = !fullscreen;
        try {
            Display.setFullscreen(fullscreen);
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }    
    
    
    

    /**
     * Ici tous les dessin sont fait a l'ecran
     * le "rendering"
     * @return boolean si tous c'est bien passer
     */
    private boolean render() {
    	int x, y;
        float float_x, float_y, float_xb, float_yb;

        GL11.glClear(GL11.GL_COLOR_BUFFER_BIT | GL11.GL_DEPTH_BUFFER_BIT);  // Clear The Screen And The Depth Buffer
        GL11.glLoadIdentity();                                  // Reset The View

        GL11.glTranslatef(0.0f,0.0f,-12.0f);

        GL11.glRotatef(xrot,1.0f,0.0f,0.0f);
        GL11.glRotatef(yrot,0.0f,1.0f,0.0f);
        GL11.glRotatef(zrot,0.0f,0.0f,1.0f);

        texture.bind();
     

        GL11.glBegin(GL11.GL_QUADS);
        for( x = 0; x < 44; x++ ) {
            for( y = 0; y < 44; y++ ) {
                float_x = (float)(x)/44.0f;
                float_y = (float)(y)/44.0f;
                float_xb = (float)(x+1)/44.0f;
                float_yb = (float)(y+1)/44.0f;

                GL11.glTexCoord2f( float_x, float_y);
                GL11.glVertex3f( points[x][y][0], points[x][y][1], points[x][y][2] );

                GL11.glTexCoord2f( float_x, float_yb );
                GL11.glVertex3f( points[x][y+1][0], points[x][y+1][1], points[x][y+1][2] );

                GL11.glTexCoord2f( float_xb, float_yb );
                GL11.glVertex3f( points[x+1][y+1][0], points[x+1][y+1][1], points[x+1][y+1][2] );

                GL11.glTexCoord2f( float_xb, float_y );
                GL11.glVertex3f( points[x+1][y][0], points[x+1][y][1], points[x+1][y][2] );
            }
        }
        GL11.glEnd();

        if( wiggle_count == 2 ) {
            for( y = 0; y < 45; y++ ) {
                hold=points[0][y][2];
                for( x = 0; x < 44; x++) {
                    points[x][y][2] = points[x+1][y][2];
                }
                points[44][y][2]=hold;
            }
            wiggle_count = 0;
        }

        wiggle_count++;

        xrot+=0.06f;
        yrot+=0.04f;
        zrot+=0.08f;
        
        return true;
    }

    /**
     * Cr�e la fenetre
     * @throws Exception Throws Window.create() exception.
     */
    private void createWindow() throws Exception {
    	//demande tous les mode d'affichage disponible
        DisplayMode d[] = Display.getAvailableDisplayModes();
        //parcour tous les mode retourn� et selectionne celui ou
        //hauteur = 480, largeur = 640, et ou on a 32 bits par pixel
        for (int i = 0; i < d.length; i++) {
            if (d[i].getWidth() == 640
                && d[i].getHeight() == 480
                && d[i].getBitsPerPixel() == 32) {
                displayMode = d[i];
                break;
            }
        }
        Display.setDisplayMode(displayMode);
        Display.setTitle(windowTitle);
        Display.create();
    }

    /**
     * Faire toute les initialisation ici, comme le clavier et openGL
     */
    private void init() throws Exception {
        createWindow();
        loadTextures();
        initGL();
        

        for(int x=0; x<45; x++) {
            for(int y=0; y<45; y++) {
                points[x][y][0]=(float)x/5.0f-4.5f;
                points[x][y][1]=(float)y/5.0f-4.5f;
                points[x][y][2]=(float)(Math.sin(((((double)x/5.0)*40.0)/360.0)*Math.PI*2.0));
            }
        }
    }
    
    private void loadTextures() throws IOException {
    	texture = TextureLoader.getTexture("PNG", ResourceLoader.getResourceAsStream("src/textures/fr.png"));
    }

    /**
     * nettoyage.
     */
    private void Destroy() {
        Display.destroy();
    }

}




