package com.github.eldosa.nehe.tuto;
/*
 *      This Code Was Created By Jeff Molofee 2000
 *      Modified by Shawn T. to handle (%3.2f, num) parameters.
 *      A HUGE Thanks To Fredric Echols For Cleaning Up
 *      And Optimizing The Base Code, Making It More Flexible!
 *      If You've Found This Code Useful, Please Let Me Know.
 *      Visit My Site At nehe.gamedev.net
 */
import java.io.IOException;


import org.lwjgl.input.Keyboard;
import org.lwjgl.opengl.Display;
import org.lwjgl.opengl.DisplayMode;
import org.lwjgl.opengl.GL11;
import org.lwjgl.util.glu.GLU;
import org.newdawn.slick.opengl.Texture;
import org.newdawn.slick.opengl.TextureLoader;
import org.newdawn.slick.util.ResourceLoader;

/**
 * @author Mark Bernard
 * date:    26-May-2004
 *
 * Ported directly from the C++ version
 *
 * The main point of this tutorial is to get fonts on the screen.  The original OpenGL did
 * not port directly as it used Windows specific extensions and I could not get some OpenGL
 * commands to work.  In the end, what you see on the screen is the same, but it is written
 * somewhat differently.  I have noted the differences in the code with comments.
 *
 * 2004-10-08: Updated to version 0.92alpha of LWJGL.
 * 2004-12-19: Updated to version 0.94alpha of LWJGL
 */


/**
 * @author Thongvan Alexis
 * date:    25-FEV-2013
 * 
 * I don't take credit for anything, those tutorial are from nehe.
 * 
 * But it's 2013 and some stuff don't work anymore so I converted them
 * to lwgjl 2.8.5 and I'm using slick.opengl.TextureLoader instead of devil.IL to load texture
 * (since devil.IL does not exist anymore)
 * 
 * Plus if you get this from github it's in a nice maven project which will download
 * for you lwgjl and slick and package everything, plug and play baby.
 * 
 * this code is CPU-dependant, meaning : 
 * if you have a slow pc the animation will be slow
 * if you have the same pc than me the animation will run at normal speed
 * if you have a faster pc than me the animation will run faster
 * 
 * Video tutorial explaining how to set up maven, eclipse, etc : <Not available yet>
 */

public class Tut12 {
    
    private boolean done = false;
    private boolean fullscreen = false;
    private final String windowTitle = "Display list";
    private boolean F = false;
    private DisplayMode displayMode;

    private int box;                // Storage For The Box Display List
    private int top;                // Storage For The Top Display List
    private int xloop;              // Loop For X Axis
    private int yloop;              // Loop For Y Axis

    private float xrot;             // Rotates Cube On The X Axis
    private float yrot;             // Rotates Cube On The Y Axis

    private float boxcol[][] = {
        {1.0f,0.0f,0.0f},
        {1.0f,0.5f,0.0f},
        {1.0f,1.0f,0.0f},
        {0.0f,1.0f,0.0f},
        {0.0f,1.0f,1.0f}
    };

    private float topcol[][] = {
        {.5f,0.0f,0.0f},
        {0.5f,0.25f,0.0f},
        {0.5f,0.5f,0.0f},
        {0.0f,0.5f,0.0f},
        {0.0f,0.5f,0.5f}
    };

    private Texture texture;                               
    
    public static void main(String args[]) {
        Tut12 t12 = new Tut12();
        t12.run();
    }

    /**
     * Init OpenGL
     *
     */
    private void initGL() {
    	
        GL11.glEnable(GL11.GL_TEXTURE_2D);//texture mapping 
        GL11.glShadeModel(GL11.GL_SMOOTH);//smooth shading 
        GL11.glClearColor(0.0f, 0.0f, 0.0f, 0.0f);//couleur de fond noire
        GL11.glClearDepth(1.0);//setup du buffer de profondeur 
        GL11.glEnable(GL11.GL_DEPTH_TEST);//permet le test de profondeur 
        GL11.glDepthFunc(GL11.GL_LEQUAL); //le type de test de profondeur a faire
        
        GL11.glEnable(GL11.GL_LIGHT0);                              // Quick And Dirty Lighting (Assumes Light0 Is Set Up)
        GL11.glEnable(GL11.GL_LIGHTING);                            // Enable Lighting
        GL11.glEnable(GL11.GL_COLOR_MATERIAL);                      // Enable Material Coloring 
        
        GL11.glMatrixMode(GL11.GL_PROJECTION);//selectrione la matrice de projection    
        GL11.glLoadIdentity();//reset la matrice de projection
        // Calcul l'aspect ratio de la fenetre
        GLU.gluPerspective(
          45.0f,
          (float) displayMode.getWidth() / (float) displayMode.getHeight(),
          0.1f,
          100.0f);
          
          GL11.glMatrixMode(GL11.GL_MODELVIEW);//selectionne la modelview Matrix
          // met les melleur parametre
          GL11.glHint(GL11.GL_PERSPECTIVE_CORRECTION_HINT, GL11.GL_NICEST);
    
    }    
    
    /**
     * Boucle principale
     */
    public void run() {
        try {
            init();
            while (!done) {
                readAndAct();
                render();
                Display.update();
                Thread.sleep(7);
            }
            Destroy();
        }
        catch (Exception e) {
            e.printStackTrace();
            System.exit(0);
        }
    }

    /**
     * Toute les updates sont fait ici, lecture de clavier, 
     * lecture de souris, agissement IA, etc
     */
    private void readAndAct() {
    	if(Keyboard.isKeyDown(Keyboard.KEY_ESCAPE)) {       
            done = true;
        }
        if(Display.isCloseRequested()) {                  
            done = true;
        }
        if(Keyboard.isKeyDown(Keyboard.KEY_F) && !F) {    
            F = true;                                    
            toggle();                                  
        }
        if(!Keyboard.isKeyDown(Keyboard.KEY_F)) {       
            F = false;
        }
        if (Keyboard.isKeyDown(Keyboard.KEY_LEFT)) {
            yrot -= 0.2f;
        }
        if (Keyboard.isKeyDown(Keyboard.KEY_RIGHT)) {
            yrot += 0.2f;
        }
        if (Keyboard.isKeyDown(Keyboard.KEY_UP)) {
            xrot -= 0.2f;
        }
        if (Keyboard.isKeyDown(Keyboard.KEY_DOWN)) {
            xrot += 0.2f;
        }
 
    }
    
    private void toggle() {
        fullscreen = !fullscreen;
        try {
            Display.setFullscreen(fullscreen);
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }    
    
    
    

    /**
     * Ici tous les dessin sont fait a l'ecran
     * le "rendering"
     * @return boolean si tous c'est bien passer
     */
    private boolean render() {
        GL11.glClear(GL11.GL_COLOR_BUFFER_BIT | GL11.GL_DEPTH_BUFFER_BIT);  // Clear The Screen And The Depth Buffer

        texture.bind();
        for (int i=1;i<6;i++) {
            for (int j=0;j<i;j++) {
                GL11.glLoadIdentity();                          // Reset The View
                GL11.glTranslatef(1.4f+((float)j*2.8f)-((float)i*1.4f),((6.0f-(float)i)*2.4f)-7.0f,-20.0f);
                GL11.glRotatef(45.0f-(2.0f*i)+xrot,1.0f,0.0f,0.0f);
                GL11.glRotatef(45.0f+yrot,0.0f,1.0f,0.0f);
                //GL11.glColor3f(boxcol[i-1][0],boxcol[i-1][1],boxcol[i-1][2]);
                GL11.glCallList(box);
               // GL11.glColor3f(topcol[i-1][0],topcol[i-1][1],topcol[i-1][2]);
                GL11.glCallList(top);
            }
        }
        return true;
    }

    /**
     * Cr�e la fenetre
     * @throws Exception Throws Window.create() exception.
     */
    private void createWindow() throws Exception {
    	//demande tous les mode d'affichage disponible
        DisplayMode d[] = Display.getAvailableDisplayModes();
        //parcour tous les mode retourn� et selectionne celui ou
        //hauteur = 480, largeur = 640, et ou on a 32 bits par pixel
        for (int i = 0; i < d.length; i++) {
            if (d[i].getWidth() == 640
                && d[i].getHeight() == 480
                && d[i].getBitsPerPixel() == 32) {
                displayMode = d[i];
                break;
            }
        }
        Display.setDisplayMode(displayMode);
        Display.setTitle(windowTitle);
        Display.create();
    }

    /**
     * Faire toute les initialisation ici, comme le clavier et openGL
     */
    private void init() throws Exception {
        createWindow();
        loadTextures();
        initGL();
        buildLists();
    }
    
    private void loadTextures() throws IOException {
    	texture = TextureLoader.getTexture("PNG", ResourceLoader.getResourceAsStream("src/textures/m like/grass/bottom.png"));
    }

    /**
     * nettoyage.
     */
    private void Destroy() {
        Display.destroy();
    }
    
    private void buildLists() {
        box = GL11.glGenLists(2);                                   // Generate 2 Different Lists
        GL11.glNewList(box,GL11.GL_COMPILE);                            // Start With The Box List
            GL11.glBegin(GL11.GL_QUADS);
                // Bottom Face
                GL11.glNormal3f( 0.0f,-1.0f, 0.0f);
                GL11.glTexCoord2f(1.0f, 1.0f); GL11.glVertex3f(-1.0f, -1.0f, -1.0f);
                GL11.glTexCoord2f(0.0f, 1.0f); GL11.glVertex3f( 1.0f, -1.0f, -1.0f);
                GL11.glTexCoord2f(0.0f, 0.0f); GL11.glVertex3f( 1.0f, -1.0f,  1.0f);
                GL11.glTexCoord2f(1.0f, 0.0f); GL11.glVertex3f(-1.0f, -1.0f,  1.0f);
                // Front Face
                GL11.glNormal3f( 0.0f, 0.0f, 1.0f);
                GL11.glTexCoord2f(0.0f, 0.0f); GL11.glVertex3f(-1.0f, -1.0f,  1.0f);
                GL11.glTexCoord2f(1.0f, 0.0f); GL11.glVertex3f( 1.0f, -1.0f,  1.0f);
                GL11.glTexCoord2f(1.0f, 1.0f); GL11.glVertex3f( 1.0f,  1.0f,  1.0f);
                GL11.glTexCoord2f(0.0f, 1.0f); GL11.glVertex3f(-1.0f,  1.0f,  1.0f);
                // Back Face
                GL11.glNormal3f( 0.0f, 0.0f,-1.0f);
                GL11.glTexCoord2f(1.0f, 0.0f); GL11.glVertex3f(-1.0f, -1.0f, -1.0f);
                GL11.glTexCoord2f(1.0f, 1.0f); GL11.glVertex3f(-1.0f,  1.0f, -1.0f);
                GL11.glTexCoord2f(0.0f, 1.0f); GL11.glVertex3f( 1.0f,  1.0f, -1.0f);
                GL11.glTexCoord2f(0.0f, 0.0f); GL11.glVertex3f( 1.0f, -1.0f, -1.0f);
                // Right face
                GL11.glNormal3f( 1.0f, 0.0f, 0.0f);
                GL11.glTexCoord2f(1.0f, 0.0f); GL11.glVertex3f( 1.0f, -1.0f, -1.0f);
                GL11.glTexCoord2f(1.0f, 1.0f); GL11.glVertex3f( 1.0f,  1.0f, -1.0f);
                GL11.glTexCoord2f(0.0f, 1.0f); GL11.glVertex3f( 1.0f,  1.0f,  1.0f);
                GL11.glTexCoord2f(0.0f, 0.0f); GL11.glVertex3f( 1.0f, -1.0f,  1.0f);
                // Left Face
                GL11.glNormal3f(-1.0f, 0.0f, 0.0f);
                GL11.glTexCoord2f(0.0f, 0.0f); GL11.glVertex3f(-1.0f, -1.0f, -1.0f);
                GL11.glTexCoord2f(1.0f, 0.0f); GL11.glVertex3f(-1.0f, -1.0f,  1.0f);
                GL11.glTexCoord2f(1.0f, 1.0f); GL11.glVertex3f(-1.0f,  1.0f,  1.0f);
                GL11.glTexCoord2f(0.0f, 1.0f); GL11.glVertex3f(-1.0f,  1.0f, -1.0f);
            GL11.glEnd();
        GL11.glEndList();
        top = box+1;                                            // Storage For "Top" Is "Box" Plus One
        GL11.glNewList(top,GL11.GL_COMPILE);                            // Now The "Top" Display List
            GL11.glBegin(GL11.GL_QUADS);
                // Top Face
                GL11.glNormal3f( 0.0f, 1.0f, 0.0f);
                GL11.glTexCoord2f(0.0f, 1.0f); GL11.glVertex3f(-1.0f,  1.0f, -1.0f);
                GL11.glTexCoord2f(0.0f, 0.0f); GL11.glVertex3f(-1.0f,  1.0f,  1.0f);
                GL11.glTexCoord2f(1.0f, 0.0f); GL11.glVertex3f( 1.0f,  1.0f,  1.0f);
                GL11.glTexCoord2f(1.0f, 1.0f); GL11.glVertex3f( 1.0f,  1.0f, -1.0f);
            GL11.glEnd();
        GL11.glEndList();
    }

}




