package com.github.eldosa.nehe.tuto;
/*
 *      This Code Was Created By Jeff Molofee 2000
 *      Modified by Shawn T. to handle (%3.2f, num) parameters.
 *      A HUGE Thanks To Fredric Echols For Cleaning Up
 *      And Optimizing The Base Code, Making It More Flexible!
 *      If You've Found This Code Useful, Please Let Me Know.
 *      Visit My Site At nehe.gamedev.net
 */
import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;


import org.lwjgl.input.Keyboard;
import org.lwjgl.opengl.Display;
import org.lwjgl.opengl.DisplayMode;
import org.lwjgl.opengl.GL11;
import org.lwjgl.util.glu.GLU;
import org.newdawn.slick.opengl.Texture;
import org.newdawn.slick.opengl.TextureLoader;
import org.newdawn.slick.util.ResourceLoader;

/**
 * @author Mark Bernard
 * date:    26-May-2004
 *
 * Ported directly from the C++ version
 *
 * The main point of this tutorial is to get fonts on the screen.  The original OpenGL did
 * not port directly as it used Windows specific extensions and I could not get some OpenGL
 * commands to work.  In the end, what you see on the screen is the same, but it is written
 * somewhat differently.  I have noted the differences in the code with comments.
 *
 * 2004-10-08: Updated to version 0.92alpha of LWJGL.
 * 2004-12-19: Updated to version 0.94alpha of LWJGL
 */


/**
 * @author Thongvan Alexis
 * date:    25-FEV-2013
 * 
 * I don't take credit for anything, those tutorial are from nehe.
 * 
 * But it's 2013 and some stuff don't work anymore so I converted them
 * to lwgjl 2.8.5 and I'm using slick.opengl.TextureLoader instead of devil.IL to load texture
 * (since devil.IL does not exist anymore)
 * 
 * Plus if you get this from github it's in a nice maven project which will download
 * for you lwgjl and slick and package everything, plug and play baby.
 * 
 * this code is CPU-dependant, meaning : 
 * if you have a slow pc the animation will be slow
 * if you have the same pc than me the animation will run at normal speed
 * if you have a faster pc than me the animation will run faster
 * 
 * Video tutorial explaining how to set up maven, eclipse, etc : <Not available yet>
 */

public class Tut16 {
    
    private boolean done = false;
    private boolean fullscreen = false;
    private final String windowTitle = "NeHe's Lesson 16 (Cool Looking Fog)";
    private boolean F = false;
    private DisplayMode displayMode;

    private boolean light;                                  // Lighting ON/OFF
    private boolean lp, N;                                     // L Pressed?
    private boolean fp;                                     // F Pressed?
    private boolean gp;                                     // G Pressed? ( NEW )

    private float xrot;                                     // X Rotation
    private float yrot;                                     // Y Rotation
    private float xspeed;                                   // X Rotation Speed
    private float yspeed;                                   // Y Rotation Speed
    private float z = -5.0f;                                    // Depth Into The Screen

    private float lightAmbient[] = { 0.5f, 0.5f, 0.5f, 1.0f };
    private float lightDiffuse[] = { 1.0f, 1.0f, 1.0f, 1.0f };
    private float lightPosition[] = { 0.0f, 0.0f, 2.0f, 1.0f };
    private int filter;                                     // Which Filter To Use
    private Texture texture[] = new Texture[3];                     // Storage For 3 Textures
    private int fogMode[] = { GL11.GL_EXP, GL11.GL_EXP2, GL11.GL_LINEAR };  // Storage For Three Types Of Fog
    private int fogfilter = 0;                              // Which Fog Mode To Use
    private float fogColor[] = {0.5f, 0.5f, 0.5f, 1.0f};        // Fog Color                             
    
    public static void main(String args[]) {
        Tut16 t16 = new Tut16();
        t16.run();
    }

    /**
     * Init OpenGL
     *
     */
    private void initGL() {
        GL11.glEnable(GL11.GL_TEXTURE_2D);                                  // Enable Texture Mapping
        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE);                   // Set The Blending Function For Translucency
        GL11.glClearColor(0.5f, 0.5f, 0.5f, 0.0f);                          // This Will Clear The Background Color To Black
        GL11.glClearDepth(1.0);                                             // Enables Clearing Of The Depth Buffer
        GL11.glDepthFunc(GL11.GL_LESS);                                     // The Type Of Depth Test To Do
        GL11.glEnable(GL11.GL_DEPTH_TEST);                                  // Enables Depth Testing
        GL11.glShadeModel(GL11.GL_SMOOTH);                                  // Enables Smooth Color Shading
        GL11.glMatrixMode(GL11.GL_PROJECTION);                              // Select The Projection Matrix
        GL11.glLoadIdentity();                                              // Reset The Projection Matrix
        // Calculate The Aspect Ratio Of The Window
        GLU.gluPerspective(45.0f,
                (float) displayMode.getWidth() / (float) displayMode.getHeight(),
                0.1f,100.0f);
        GL11.glMatrixMode(GL11.GL_MODELVIEW);                               // Select The Modelview Matrix
        GL11.glHint(GL11.GL_PERSPECTIVE_CORRECTION_HINT, GL11.GL_NICEST);   // Really Nice Perspective Calculations

        ByteBuffer temp = ByteBuffer.allocateDirect(16);
        temp.order(ByteOrder.nativeOrder());
        temp.asFloatBuffer().put(lightAmbient).flip();
        GL11.glLight(GL11.GL_LIGHT1, GL11.GL_AMBIENT, temp.asFloatBuffer());    // Setup The Ambient Light
        temp.asFloatBuffer().put(lightDiffuse).flip();
        GL11.glLight(GL11.GL_LIGHT1, GL11.GL_DIFFUSE, temp.asFloatBuffer());    // Setup The Diffuse Light
        temp.asFloatBuffer().put(lightPosition).flip();
        GL11.glLight(GL11.GL_LIGHT1, GL11.GL_POSITION,temp.asFloatBuffer());    // Position The Light
        GL11.glEnable(GL11.GL_LIGHT1);                                      // Enable Light One

        GL11.glFogi(GL11.GL_FOG_MODE, fogMode[fogfilter]);                  // Fog Mode
        temp.asFloatBuffer().put(fogColor).flip();
        GL11.glFog(GL11.GL_FOG_COLOR, temp.asFloatBuffer());                // Set Fog Color
        GL11.glFogf(GL11.GL_FOG_DENSITY, 0.35f);                            // How Dense Will The Fog Be
        GL11.glHint(GL11.GL_FOG_HINT, GL11.GL_DONT_CARE);                   // Fog Hint Value
        GL11.glFogf(GL11.GL_FOG_START, 1.0f);                               // Fog Start Depth
        GL11.glFogf(GL11.GL_FOG_END, 5.0f);                                 // Fog End Depth
        GL11.glEnable(GL11.GL_FOG);                                         // Enables GL_FOG
    }
    
    /**
     * Boucle principale
     */
    public void run() {
        try {
            init();
            while (!done) {
                readAndAct();
                render();
                Display.update();
                Thread.sleep(7);
            }
            Destroy();
        }
        catch (Exception e) {
            e.printStackTrace();
            System.exit(0);
        }
    }

    /**
     * Toute les updates sont fait ici, lecture de clavier, 
     * lecture de souris, agissement IA, etc
     */
    private void readAndAct() {
    	if(Keyboard.isKeyDown(Keyboard.KEY_ESCAPE)) {       
            done = true;
        }
        if(Display.isCloseRequested()) {                  
            done = true;
        }
        if(Keyboard.isKeyDown(Keyboard.KEY_F) && !F) {    
            F = true;                                    
            toggle();                                  
        }
        if(!Keyboard.isKeyDown(Keyboard.KEY_F)) {       
            F = false;
        }
        if (Keyboard.isKeyDown(Keyboard.KEY_N) && !N) {
            N = true;
            filter += 1;
            if (filter > 2) {
                filter = 0;
            }
        }
        if (!Keyboard.isKeyDown(Keyboard.KEY_N)) {
            N = false;
        }
        if (Keyboard.isKeyDown(Keyboard.KEY_L) && !lp) {
            lp = true;
            light = !light;
            if (!light) {
                GL11.glDisable(GL11.GL_LIGHTING);
            }
            else {
                GL11.glEnable(GL11.GL_LIGHTING);
            }
        }
        if (!Keyboard.isKeyDown(Keyboard.KEY_L)) {
            lp = false;
        }
        if (Keyboard.isKeyDown(Keyboard.KEY_PRIOR)) {
            z -= 0.02f;
        }
        if (Keyboard.isKeyDown(Keyboard.KEY_NEXT)) {
            z += 0.02f;
        }
        if (Keyboard.isKeyDown(Keyboard.KEY_UP)) {
            xspeed -= 0.01f;
        }
        if (Keyboard.isKeyDown(Keyboard.KEY_DOWN)) {
            xspeed += 0.01f;
        }
        if (Keyboard.isKeyDown(Keyboard.KEY_RIGHT)) {
            yspeed += 0.01f;
        }
        if (Keyboard.isKeyDown(Keyboard.KEY_LEFT)) {
            yspeed -= 0.01f;
        }
        if (Keyboard.isKeyDown(Keyboard.KEY_G) && !gp) {
            gp = true;
            fogfilter += 1;
            if (fogfilter > 2) {
                fogfilter = 0;
            }
            GL11.glFogi (GL11.GL_FOG_MODE, fogMode[fogfilter]); // Fog Mode
        }
        if (!Keyboard.isKeyDown(Keyboard.KEY_G)) {
            gp = false;
        }
 
    }
    
    private void toggle() {
        fullscreen = !fullscreen;
        try {
            Display.setFullscreen(fullscreen);
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }    
    
    
    

    /**
     * Ici tous les dessin sont fait a l'ecran
     * le "rendering"
     * @return boolean si tous c'est bien passer
     */
    private boolean render() {

        GL11.glClear(GL11.GL_COLOR_BUFFER_BIT | GL11.GL_DEPTH_BUFFER_BIT);  // Clear The Screen And The Depth Buffer
        GL11.glLoadIdentity();                                  // Reset The View
        GL11.glTranslatef(0.0f, 0.0f, z);

        GL11.glRotatef(xrot, 1.0f, 0.0f, 0.0f);
        GL11.glRotatef(yrot, 0.0f, 1.0f, 0.0f);

        texture[filter].bind();

        GL11.glBegin(GL11.GL_QUADS);
            // Front Face
            GL11.glNormal3f( 0.0f, 0.0f, 1.0f);
            GL11.glTexCoord2f(0.0f, 0.0f); GL11.glVertex3f(-1.0f, -1.0f,  1.0f);
            GL11.glTexCoord2f(1.0f, 0.0f); GL11.glVertex3f( 1.0f, -1.0f,  1.0f);
            GL11.glTexCoord2f(1.0f, 1.0f); GL11.glVertex3f( 1.0f,  1.0f,  1.0f);
            GL11.glTexCoord2f(0.0f, 1.0f); GL11.glVertex3f(-1.0f,  1.0f,  1.0f);
            // Back Face
            GL11.glNormal3f( 0.0f, 0.0f,-1.0f);
            GL11.glTexCoord2f(1.0f, 0.0f); GL11.glVertex3f(-1.0f, -1.0f, -1.0f);
            GL11.glTexCoord2f(1.0f, 1.0f); GL11.glVertex3f(-1.0f,  1.0f, -1.0f);
            GL11.glTexCoord2f(0.0f, 1.0f); GL11.glVertex3f( 1.0f,  1.0f, -1.0f);
            GL11.glTexCoord2f(0.0f, 0.0f); GL11.glVertex3f( 1.0f, -1.0f, -1.0f);
            // Top Face
            GL11.glNormal3f( 0.0f, 1.0f, 0.0f);
            GL11.glTexCoord2f(0.0f, 1.0f); GL11.glVertex3f(-1.0f,  1.0f, -1.0f);
            GL11.glTexCoord2f(0.0f, 0.0f); GL11.glVertex3f(-1.0f,  1.0f,  1.0f);
            GL11.glTexCoord2f(1.0f, 0.0f); GL11.glVertex3f( 1.0f,  1.0f,  1.0f);
            GL11.glTexCoord2f(1.0f, 1.0f); GL11.glVertex3f( 1.0f,  1.0f, -1.0f);
            // Bottom Face
            GL11.glNormal3f( 0.0f,-1.0f, 0.0f);
            GL11.glTexCoord2f(1.0f, 1.0f); GL11.glVertex3f(-1.0f, -1.0f, -1.0f);
            GL11.glTexCoord2f(0.0f, 1.0f); GL11.glVertex3f( 1.0f, -1.0f, -1.0f);
            GL11.glTexCoord2f(0.0f, 0.0f); GL11.glVertex3f( 1.0f, -1.0f,  1.0f);
            GL11.glTexCoord2f(1.0f, 0.0f); GL11.glVertex3f(-1.0f, -1.0f,  1.0f);
            // Right face
            GL11.glNormal3f( 1.0f, 0.0f, 0.0f);
            GL11.glTexCoord2f(1.0f, 0.0f); GL11.glVertex3f( 1.0f, -1.0f, -1.0f);
            GL11.glTexCoord2f(1.0f, 1.0f); GL11.glVertex3f( 1.0f,  1.0f, -1.0f);
            GL11.glTexCoord2f(0.0f, 1.0f); GL11.glVertex3f( 1.0f,  1.0f,  1.0f);
            GL11.glTexCoord2f(0.0f, 0.0f); GL11.glVertex3f( 1.0f, -1.0f,  1.0f);
            // Left Face
            GL11.glNormal3f(-1.0f, 0.0f, 0.0f);
            GL11.glTexCoord2f(0.0f, 0.0f); GL11.glVertex3f(-1.0f, -1.0f, -1.0f);
            GL11.glTexCoord2f(1.0f, 0.0f); GL11.glVertex3f(-1.0f, -1.0f,  1.0f);
            GL11.glTexCoord2f(1.0f, 1.0f); GL11.glVertex3f(-1.0f,  1.0f,  1.0f);
            GL11.glTexCoord2f(0.0f, 1.0f); GL11.glVertex3f(-1.0f,  1.0f, -1.0f);
        GL11.glEnd();

        xrot += xspeed;
        yrot += yspeed;
        return true;
    }

    /**
     * Cr�e la fenetre
     * @throws Exception Throws Window.create() exception.
     */
    private void createWindow() throws Exception {
    	//demande tous les mode d'affichage disponible
        DisplayMode d[] = Display.getAvailableDisplayModes();
        //parcour tous les mode retourn� et selectionne celui ou
        //hauteur = 480, largeur = 640, et ou on a 32 bits par pixel
        for (int i = 0; i < d.length; i++) {
            if (d[i].getWidth() == 640
                && d[i].getHeight() == 480
                && d[i].getBitsPerPixel() == 32) {
                displayMode = d[i];
                break;
            }
        }
        Display.setDisplayMode(displayMode);
        Display.setTitle(windowTitle);
        Display.create();
    }

    /**
     * Faire toute les initialisation ici, comme le clavier et openGL
     */
    private void init() throws Exception {
        createWindow();
        loadTextures();
        initGL();
    }
    
    private void loadTextures() throws IOException {
    	texture[0] = TextureLoader.getTexture("PNG", ResourceLoader.getResourceAsStream("src/textures/m like/grass/bottom.png"));
    	texture[1] = TextureLoader.getTexture("PNG", ResourceLoader.getResourceAsStream("src/textures/m like/grass/top.png"));
    	texture[2] = TextureLoader.getTexture("JPG", ResourceLoader.getResourceAsStream("src/textures/tut7tex3.jpg"));
    }

    /**
     * nettoyage.
     */
    private void Destroy() {
        Display.destroy();
    }
    


}




