package com.github.eldosa.nehe.tuto;
/*
 *      This Code Was Created By Jeff Molofee 2000
 *      Modified by Shawn T. to handle (%3.2f, num) parameters.
 *      A HUGE Thanks To Fredric Echols For Cleaning Up
 *      And Optimizing The Base Code, Making It More Flexible!
 *      If You've Found This Code Useful, Please Let Me Know.
 *      Visit My Site At nehe.gamedev.net
 */
import java.io.IOException;

/**
 * @author Mark Bernard
 * date:    26-May-2004
 *
 *
 * Ported directly from the C++ version
 *
 * The main point of this tutorial is to get fonts on the screen.  The original OpenGL did
 * not port directly as it used Windows specific extensions and I could not get some OpenGL
 * commands to work.  In the end, what you see on the screen is the same, but it is written
 * somewhat differently.  I have noted the differences in the code with comments.
 *
 * 2004-10-08: Updated to version 0.92alpha of LWJGL.
 * 2004-12-19: Updated to version 0.94alpha of LWJGL
 */


/**
 * @author Thongvan Alexis
 * date:    25-FEV-2013
 * 
 * I don't take credit for anything, those tutorial are from nehe.
 * 
 * But it's 2013 and some stuff don't work anymore so I converted them
 * to lwgjl 2.8.5 and I'm using slick.opengl.TextureLoader instead of devil.IL to load texture
 * (since devil.IL does not exist anymore)
 * 
 * Plus if you get this from github it's in a nice maven project which will download
 * for you lwgjl and slick and package everything, plug and play baby.
 * 
 * this code is CPU-dependant, meaning : 
 * if you have a slow pc the animation will be slow
 * if you have the same pc than me the animation will run at normal speed
 * if you have a faster pc than me the animation will run faster 
 * 
 * Video tutorial explaining how to set up maven, eclipse, etc : <Not available yet>
 */

import org.lwjgl.input.Keyboard;
import org.lwjgl.opengl.Display;
import org.lwjgl.opengl.DisplayMode;
import org.lwjgl.opengl.GL11;
import org.lwjgl.util.glu.GLU;
import org.newdawn.slick.opengl.Texture;
import org.newdawn.slick.opengl.TextureLoader;
import org.newdawn.slick.util.ResourceLoader;


public class Tut17 {
    
    private boolean done = false;
    private boolean fullscreen = false;
    private final String windowTitle = "NeHe's OpenGL Lesson 13 for LWJGL (Bitmap Fonts)";
    private boolean f1 = false;
    private DisplayMode displayMode;

    private Texture texture[] = new Texture[2];
    private int base;                       // Base Display List For The Font Set
    private float cnt1;                     // 1st Counter Used To Move Text & For Coloring
    private float cnt2;                     // 2nd Counter Used To Move Text & F                            
    
    public static void main(String args[]) {
        Tut17 t16 = new Tut17();
        t16.run();
    }

    /**
     * Init OpenGL
     *
     */
    private void initGL() {                                     // All Setup For OpenGL Goes Here
        GL11.glClearColor(0.0f, 0.0f, 0.0f, 0.0f);              // Clear The Background Color To Black
        GL11.glClearDepth(1.0);                                 // Enables Clearing Of The Depth Buffer
        GL11.glDepthFunc(GL11.GL_LEQUAL);                       // The Type Of Depth Test To Do
        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE);       // Select The Type Of Blending
        GL11.glShadeModel(GL11.GL_SMOOTH);                      // Enables Smooth Color Shading
        GL11.glEnable(GL11.GL_TEXTURE_2D);                      // Enable 2D Texture Mapping
        GL11.glMatrixMode(GL11.GL_PROJECTION);
        // Select The Projection Matrix
        GL11.glLoadIdentity(); // Reset The Projection Matrix

        // Calculate The Aspect Ratio Of The Window
        GLU.gluPerspective(45.0f,
                (float) displayMode.getWidth() / (float) displayMode.getHeight(),
                0.1f,100.0f);
        GL11.glMatrixMode(GL11.GL_MODELVIEW);
    }
    /**
     * Boucle principale
     */
    public void run() {
        try {
            init();
            while (!done) {
                readAndAct();
                render();
                Display.update();
                Thread.sleep(7);
            }
            Destroy();
        }
        catch (Exception e) {
            e.printStackTrace();
            System.exit(0);
        }
    }

    /**
     * Toute les updates sont fait ici, lecture de clavier, 
     * lecture de souris, agissement IA, etc
     */
    private void readAndAct() {
        if(Keyboard.isKeyDown(Keyboard.KEY_ESCAPE)) {       // Exit if Escape is pressed
            done = true;
        }
        if(Display.isCloseRequested()) {                     // Exit if window is closed
            done = true;
        }
        if(Keyboard.isKeyDown(Keyboard.KEY_F1) && !f1) {    // Is F1 Being Pressed?
            f1 = true;                                      // Tell Program F1 Is Being Held
            toggle();                                   // Toggle Fullscreen / Windowed Mode
        }
        if(!Keyboard.isKeyDown(Keyboard.KEY_F1)) {          // Is F1 Being Pressed?
            f1 = false;
        }

    }
    
    private void toggle() {
        fullscreen = !fullscreen;
        try {
            Display.setFullscreen(fullscreen);
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }    
    
    
    

    /**
     * Ici tous les dessin sont fait a l'ecran
     * le "rendering"
     * @return boolean si tous c'est bien passer
     */
    private boolean render() {

        GL11.glClear(GL11.GL_COLOR_BUFFER_BIT | GL11.GL_DEPTH_BUFFER_BIT);  // Clear The Screen And The Depth Buffer
        GL11.glLoadIdentity();                                              // Reset The Modelview Matrix
        GL11.glTranslatef(0.0f, 0.0f, -5.0f);                               // Move Into The Screen 5 Units
        GL11.glRotatef(45.0f, 0.0f, 0.0f, 1.0f);                            // Rotate On The Z Axis 45 Degrees (Clockwise)
        GL11.glRotatef(cnt1 * 30.0f, 1.0f, 1.0f, 0.0f);                     // Rotate On The X & Y Axis By cnt1 (Left To Right)
        GL11.glDisable(GL11.GL_BLEND);                                      // Disable Blending Before We Draw In 3D
        GL11.glColor3f(1.0f, 1.0f, 1.0f);                                   // Bright White

        texture[1].bind();               // Select Our Second Texture
        GL11.glBegin(GL11.GL_QUADS); {                                        // Draw Our First Texture Mapped Quad
            GL11.glTexCoord2f(0.0f, 1.0f);                                      // First Texture Coord
            GL11.glVertex3f(-1.0f, 1.0f, 0.0f);                                       // First Vertex
            GL11.glTexCoord2f(1.0f, 1.0f);                                      // Second Texture Coord
            GL11.glVertex3f( 1.0f, 1.0f, 0.0f);                                       // Second Vertex
            GL11.glTexCoord2f(1.0f, 0.0f);                                      // Third Texture Coord
            GL11.glVertex3f( 1.0f, -1.0f, 0.0f);                                      // Third Vertex
            GL11.glTexCoord2f(0.0f, 0.0f);                                      // Fourth Texture Coord
            GL11.glVertex3f(-1.0f, -1.0f, 0.0f);                                      // Fourth Vertex
        }
        GL11.glEnd();                                                       // Done Drawing The First Quad
        GL11.glRotatef(90.0f, 1.0f, 1.0f, 0.0f);                            // Rotate On The X & Y Axis By 90 Degrees (Left To Right)
        GL11.glBegin(GL11.GL_QUADS); {                                        // Draw Our Second Texture Mapped Quad
            GL11.glTexCoord2f(0.0f, 0.0f);                                      // First Texture Coord
            GL11.glVertex2f(-1.0f, 1.0f);                                       // First Vertex
            GL11.glTexCoord2f(1.0f, 0.0f);                                      // Second Texture Coord
            GL11.glVertex2f( 1.0f, 1.0f);                                       // Second Vertex
            GL11.glTexCoord2f(1.0f, 1.0f);                                      // Third Texture Coord
            GL11.glVertex2f( 1.0f, -1.0f);                                      // Third Vertex
            GL11.glTexCoord2f(0.0f, 1.0f);                                      // Fourth Texture Coord
            GL11.glVertex2f(-1.0f, -1.0f);                                      // Fourth Vertex
        }
        GL11.glEnd();                                                       // Done Drawing Our Second Quad
        GL11.glEnable(GL11.GL_BLEND);                                       // Enable Blending

        GL11.glLoadIdentity();                                              // Reset The View
        // Pulsing Colors Based On Text Position
        GL11.glColor3f(
            1.0f * ((float)Math.cos(cnt1)),
            1.0f * ((float)Math.sin(cnt2)),
            1.0f - 0.5f * ((float)Math.cos(cnt1 + cnt2)));
        glPrint(                                                            // Print GL Text To The Screen
            ((int)(280 + 250 * Math.cos(cnt1))),
            ((int)(235 + 200 * Math.sin(cnt2))),
            "NeHe", 0);

        GL11.glColor3f(
            1.0f * ((float)Math.sin(cnt2)),
            1.0f - 0.5f * ((float)Math.cos(cnt1 + cnt2)),
            1.0f * ((float)Math.cos(cnt1)));
        glPrint(                                                            // Print GL Text To The Screen
            ((int)(280 + 230 * Math.cos(cnt2))),
            ((int)(235 + 200 * Math.sin(cnt1))),
            "OpenGL", 1);


        GL11.glColor3f(0.0f, 0.0f, 1.0f);                                   // Set Color To Blue
        glPrint(
            ((int)(240 + 200 * Math.cos((cnt2 + cnt1) / 5))),
            2,
            "Giuseppe D'Agata", 0);

        GL11.glColor3f(1.0f, 1.0f, 1.0f);                                   // Set Color To White
        glPrint(
            ((int)(242 + 200 * Math.cos((cnt2 + cnt1) / 5))),
            2,
            "Giuseppe D'Agata",
            0);

        cnt1 += 0.01f;                                                        // Increase The First Counter
        cnt2 += 0.0081f;                                                      // Increase The Second Counter
        return true;
    }

    /**
     * Cr�e la fenetre
     * @throws Exception Throws Window.create() exception.
     */
    private void createWindow() throws Exception {
    	//demande tous les mode d'affichage disponible
        DisplayMode d[] = Display.getAvailableDisplayModes();
        //parcour tous les mode retourn� et selectionne celui ou
        //hauteur = 480, largeur = 640, et ou on a 32 bits par pixel
        for (int i = 0; i < d.length; i++) {
            if (d[i].getWidth() == 640
                && d[i].getHeight() == 480
                && d[i].getBitsPerPixel() == 32) {
                displayMode = d[i];
                break;
            }
        }
        Display.setDisplayMode(displayMode);
        Display.setTitle(windowTitle);
        Display.create();
    }

    /**
     * Faire toute les initialisation ici, comme le clavier et openGL
     */
    private void init() throws Exception {
        createWindow();
        loadTextures();
        initGL();
        buildFont();  
    }
    
    private void loadTextures() throws IOException {
    	texture[0] = TextureLoader.getTexture("BMP", ResourceLoader.getResourceAsStream("src/textures/Font.bmp"));
    	texture[1] = TextureLoader.getTexture("BMP", ResourceLoader.getResourceAsStream("src/textures/Bumps.bmp"));
    }

    /**
     * nettoyage.
     */
    private void Destroy() {
        Display.destroy();
    }
    
    private void glPrint(int x, int y, String msg, int set) {   // Where The Printing Happens
        if (set>1) {
            set=1;
        }
        texture[0].bind();           // Select Our Font Texture
        GL11.glDisable(GL11.GL_DEPTH_TEST);                           // Disables Depth Testing
        GL11.glMatrixMode(GL11.GL_PROJECTION);                        // Select The Projection Matrix
        GL11.glPushMatrix();                                     // Store The Projection Matrix
        GL11.glLoadIdentity();                                   // Reset The Projection Matrix
        GL11.glOrtho(0, 640, 0, 480, -1, 1);                          // Set Up An Ortho Screen
        GL11.glMatrixMode(GL11.GL_MODELVIEW);                         // Select The Modelview Matrix
        GL11.glPushMatrix();                                     // Store The Modelview Matrix
        GL11.glLoadIdentity();                                   // Reset The Modelview Matrix
        GL11.glTranslatef(x, y, 0);                                // Position The Text (0,0 - Bottom Left)
        int baseOffset = base - 32 + (128 * set);                // Choose The Font Set (0 or 1)
        for(int i=0;i<msg.length();i++) {
            GL11.glCallList(baseOffset + msg.charAt(i));
            GL11.glTranslatef(1.0f, 0.0f, 0.0f);
        }
        GL11.glMatrixMode(GL11.GL_PROJECTION);                        // Select The Projection Matrix
        GL11.glPopMatrix();                                      // Restore The Old Projection Matrix
        GL11.glMatrixMode(GL11.GL_MODELVIEW);                         // Select The Modelview Matrix
        GL11.glPopMatrix();                                      // Restore The Old Projection Matrix
        GL11.glEnable(GL11.GL_DEPTH_TEST);                            // Enables Depth Testing
    }
    
    
    private void buildFont() {                                  // Build Our Font Display List
        float   cx;                                             // Holds Our X Character Coord
        float   cy;                                             // Holds Our Y Character Coord

        base = GL11.glGenLists(256);                            // Creating 256 Display Lists
        texture[0].bind();     // Select Our Font Texture
        for (int i=0;i<256;i++) {                               // Loop Through All 256 Lists
            cx = ((float)(i % 16)) / 16.0f;                     // X Position Of Current Character
            cy = ((float)(i / 16)) / 16.0f;                     // Y Position Of Current Character

            GL11.glNewList(base + i, GL11.GL_COMPILE);          // Start Building A List
            GL11.glBegin(GL11.GL_QUADS);                        // Use A Quad For Each Character
            GL11.glTexCoord2f(cx, 1 - cy - 0.0625f);            // Texture Coord (Bottom Left)
            GL11.glVertex2i(0, 0);                              // Vertex Coord (Bottom Left)
            GL11.glTexCoord2f(cx + 0.0625f, 1 - cy - 0.0625f);  // Texture Coord (Bottom Right)
            GL11.glVertex2i(16,0);                              // Vertex Coord (Bottom Right)
            GL11.glTexCoord2f(cx + 0.0625f, 1 - cy);            // Texture Coord (Top Right)
            GL11.glVertex2i(16,16);                             // Vertex Coord (Top Right)
            GL11.glTexCoord2f(cx, 1 - cy);                      // Texture Coord (Top Left)
            GL11.glVertex2i(0, 16);                             // Vertex Coord (Top Left)
            GL11.glEnd();                                       // Done Building Our Quad (Character)
            GL11.glTranslatef(10.0f, 0.0f, 0.0f);               // Move To The Right Of The Character
            GL11.glEndList();                                   // Done Building The Display List
        }                                                       // Loop Until All 256 Are Built
    }

}




