package com.github.eldosa.nehe.tuto;
/*
 *      This Code Was Created By Jeff Molofee 2000
 *      Modified by Shawn T. to handle (%3.2f, num) parameters.
 *      A HUGE Thanks To Fredric Echols For Cleaning Up
 *      And Optimizing The Base Code, Making It More Flexible!
 *      If You've Found This Code Useful, Please Let Me Know.
 *      Visit My Site At nehe.gamedev.net
 */
import org.lwjgl.input.Keyboard;
import org.lwjgl.opengl.Display;
import org.lwjgl.opengl.DisplayMode;
import org.lwjgl.opengl.GL11;
import org.lwjgl.util.glu.GLU;
import org.newdawn.slick.opengl.Texture;
import org.newdawn.slick.opengl.TextureLoader;
import org.newdawn.slick.util.ResourceLoader;


/**
 * @author Mark Bernard
 * date:    26-May-2004
 *
 *
 * Ported directly from the C++ version
 *
 * The main point of this tutorial is to get fonts on the screen.  The original OpenGL did
 * not port directly as it used Windows specific extensions and I could not get some OpenGL
 * commands to work.  In the end, what you see on the screen is the same, but it is written
 * somewhat differently.  I have noted the differences in the code with comments.
 *
 * 2004-10-08: Updated to version 0.92alpha of LWJGL.
 * 2004-12-19: Updated to version 0.94alpha of LWJGL
 */


/**
 * @author Thongvan Alexis
 * date:    25-FEV-2013
 * 
 * I don't take credit for anything, those tutorial are from nehe.
 * 
 * But it's 2013 and some stuff don't work anymore so I converted them
 * to lwgjl 2.8.5 and I'm using slick.opengl.TextureLoader instead of devil.IL to load texture
 * (since devil.IL does not exist anymore)
 * 
 * Plus if you get this from github it's in a nice maven project which will download
 * for you lwgjl and slick and package everything, plug and play baby.
 * 
 * this code is CPU-dependant, meaning : 
 * if you have a slow pc the animation will be slow
 * if you have the same pc than me the animation will run at normal speed
 * if you have a faster pc than me the animation will run faster
 * 
 * Video tutorial explaining how to set up maven, eclipse, etc : <Not available yet>
 */


public class Tut20 {
    private boolean done = false;
    private boolean fullscreen = false;
    private final String windowTitle = "NeHe's OpenGL Lesson 20 for LWJGL (Masking)";
    private boolean f1 = false; // F1 key pressed
    private DisplayMode displayMode;
    private Texture[] texture = new Texture[5]; 
    boolean masking = true;     // Masking On/Off
    boolean mp;                 // M Pressed?
    boolean sp;                 // Space Pressed?
    boolean scene;              // Which Scene To Draw

 

    float roll;                 // Rolling Texture

    
    public static void main(String args[]) {
        Tut20 t1 = new Tut20();
        t1.run();
    }

    /**
     * Boucle principale
     */
    public void run() {
        try {
            init();
            while (!done) {
                readAndAct();
                render();
                Display.update();
                Thread.sleep(5);
            }
            Destroy();
        }
        catch (Exception e) {
            e.printStackTrace();
            System.exit(0);
        }
    }

    /**
     * Toute les updates sont fait ici, lecture de clavier, 
     * lecture de souris, agissement IA, etc
     */
    private void readAndAct() {
    	if(Keyboard.isKeyDown(Keyboard.KEY_ESCAPE)) {       // Exit if Escape is pressed
            done = true;
        }
        if(Display.isCloseRequested()) {                     // Exit if window is closed
            done = true;
        }
        if(Keyboard.isKeyDown(Keyboard.KEY_F1) && !f1) {    // Is F1 Being Pressed?
            f1 = true;                                      // Tell Program F1 Is Being Held
            toggle();                                   // Toggle Fullscreen / Windowed Mode
        }
        if(!Keyboard.isKeyDown(Keyboard.KEY_F1)) {          // Is F1 Being Pressed?
            f1 = false;
        }
        if(Keyboard.isKeyDown(Keyboard.KEY_SPACE) && !sp) { // Is Space Being Pressed?
            sp = true;                                      // Tell Program Spacebar Is Being Held
            scene = !scene;                                 // Toggle From One Scene To The Other
        }
        if(!Keyboard.isKeyDown(Keyboard.KEY_SPACE)) {       // Has Spacebar Been Released?
            sp = false;                                     // Tell Program Spacebar Has Been Released
        }
        if(Keyboard.isKeyDown(Keyboard.KEY_M) && !mp) {     // Is M Being Pressed?
            mp = true;                                      // Tell Program M Is Being Held
            masking = !masking;                             // Toggle Masking Mode OFF/ON
        }
        if(!Keyboard.isKeyDown(Keyboard.KEY_M)) {           // Has M Been Released?
            mp = false;                                     // Tell Program That M Has Been Released
        }
    }
    
    private void toggle() {
        fullscreen = !fullscreen;
        try {
            Display.setFullscreen(fullscreen);
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }    
    
    
    

    /**
     * Ici tous les dessin sont fait a l'ecran
     * le "rendering"
     * @return boolean si tous c'est bien passer
     */
    private boolean render() {
    	GL11.glClear(GL11.GL_COLOR_BUFFER_BIT | GL11.GL_DEPTH_BUFFER_BIT);     // Clear Screen And Depth Buffer
        GL11.glLoadIdentity();                                       // Reset The ModelView Matrix
        GL11.glTranslatef(0.0f,0.0f,-2.0f);                      // Move Into The Screen 5 Units

        texture[0].bind();           // Select Our Logo Texture
        GL11.glBegin(GL11.GL_QUADS);                                  // Start Drawing A Textured Quad
            GL11.glTexCoord2f(0.0f, -roll+0.0f); GL11.glVertex3f(-1.1f, -1.1f,  0.0f);    // Bottom Left
            GL11.glTexCoord2f(3.0f, -roll+0.0f); GL11.glVertex3f( 1.1f, -1.1f,  0.0f);    // Bottom Right
            GL11.glTexCoord2f(3.0f, -roll+3.0f); GL11.glVertex3f( 1.1f,  1.1f,  0.0f);    // Top Right
            GL11.glTexCoord2f(0.0f, -roll+3.0f); GL11.glVertex3f(-1.1f,  1.1f,  0.0f);    // Top Left
        GL11.glEnd();                                            // Done Drawing The Quad

        GL11.glEnable(GL11.GL_BLEND);                                 // Enable Blending
        GL11.glDisable(GL11.GL_DEPTH_TEST);                           // Disable Depth Testing

        if (masking)                                        // Is Masking Enabled?
        {
            GL11.glBlendFunc(GL11.GL_DST_COLOR,GL11.GL_ZERO);              // Blend Screen Color With Zero (Black)
        }

        if (scene)                                          // Are We Drawing The Second Scene?
        {
            GL11.glTranslatef(0.0f,0.0f,-1.0f);                  // Translate Into The Screen One Unit
            GL11.glRotatef(roll*360,0.0f,0.0f,1.0f);             // Rotate On The Z Axis 360 Degrees.
            if (masking)                                    // Is Masking On?
            {
                texture[3].bind();   // Select The Second Mask Texture
                GL11.glBegin(GL11.GL_QUADS);                          // Start Drawing A Textured Quad
                    GL11.glTexCoord2f(0.0f, 0.0f); GL11.glVertex3f(-1.1f, -1.1f,  0.0f);  // Bottom Left
                    GL11.glTexCoord2f(1.0f, 0.0f); GL11.glVertex3f( 1.1f, -1.1f,  0.0f);  // Bottom Right
                    GL11.glTexCoord2f(1.0f, 1.0f); GL11.glVertex3f( 1.1f,  1.1f,  0.0f);  // Top Right
                    GL11.glTexCoord2f(0.0f, 1.0f); GL11.glVertex3f(-1.1f,  1.1f,  0.0f);  // Top Left
                GL11.glEnd();                                    // Done Drawing The Quad
            }

            GL11.glBlendFunc(GL11.GL_ONE, GL11.GL_ONE);                    // Copy Image 2 Color To The Screen
            texture[4].bind();       // Select The Second Image Texture
            GL11.glBegin(GL11.GL_QUADS);                              // Start Drawing A Textured Quad
                GL11.glTexCoord2f(0.0f, 0.0f); GL11.glVertex3f(-1.1f, -1.1f,  0.0f);  // Bottom Left
                GL11.glTexCoord2f(1.0f, 0.0f); GL11.glVertex3f( 1.1f, -1.1f,  0.0f);  // Bottom Right
                GL11.glTexCoord2f(1.0f, 1.0f); GL11.glVertex3f( 1.1f,  1.1f,  0.0f);  // Top Right
                GL11.glTexCoord2f(0.0f, 1.0f); GL11.glVertex3f(-1.1f,  1.1f,  0.0f);  // Top Left
            GL11.glEnd();                                        // Done Drawing The Quad
        }
        else                                                // Otherwise
        {
            if (masking)                                    // Is Masking On?
            {
                texture[1].bind();   // Select The First Mask Texture
                GL11.glBegin(GL11.GL_QUADS);                          // Start Drawing A Textured Quad
                    GL11.glTexCoord2f(roll+0.0f, 0.0f); GL11.glVertex3f(-1.1f, -1.1f,  0.0f); // Bottom Left
                    GL11.glTexCoord2f(roll+4.0f, 0.0f); GL11.glVertex3f( 1.1f, -1.1f,  0.0f); // Bottom Right
                    GL11.glTexCoord2f(roll+4.0f, 4.0f); GL11.glVertex3f( 1.1f,  1.1f,  0.0f); // Top Right
                    GL11.glTexCoord2f(roll+0.0f, 4.0f); GL11.glVertex3f(-1.1f,  1.1f,  0.0f); // Top Left
                GL11.glEnd();                                    // Done Drawing The Quad
            }

            GL11.glBlendFunc(GL11.GL_ONE, GL11.GL_ONE);                    // Copy Image 1 Color To The Screen
            texture[2].bind();       // Select The First Image Texture
            GL11.glBegin(GL11.GL_QUADS);                              // Start Drawing A Textured Quad
                GL11.glTexCoord2f(roll+0.0f, 0.0f); GL11.glVertex3f(-1.1f, -1.1f,  0.0f); // Bottom Left
                GL11.glTexCoord2f(roll+4.0f, 0.0f); GL11.glVertex3f( 1.1f, -1.1f,  0.0f); // Bottom Right
                GL11.glTexCoord2f(roll+4.0f, 4.0f); GL11.glVertex3f( 1.1f,  1.1f,  0.0f); // Top Right
                GL11.glTexCoord2f(roll+0.0f, 4.0f); GL11.glVertex3f(-1.1f,  1.1f,  0.0f); // Top Left
            GL11.glEnd();                                        // Done Drawing The Quad
        }

        GL11.glEnable(GL11.GL_DEPTH_TEST);                            // Enable Depth Testing
        GL11.glDisable(GL11.GL_BLEND);                                // Disable Blending

        roll+=0.002f;                                       // Increase Our Texture Roll Variable
        if (roll>1.0f)                                      // Is Roll Greater Than One
        {
            roll-=1.0f;                                     // Subtract 1 From Roll
        }                      
        return true;
    }

    /**
     * Cr�e la fenetre
     * @throws Exception Throws Window.create() exception.
     */
    private void createWindow() throws Exception {
    	//demande tous les mode d'affichage disponible
        DisplayMode d[] = Display.getAvailableDisplayModes();
        //parcour tous les mode retourn� et selectionne celui ou
        //hauteur = 480, largeur = 640, et ou on a 32 bits par pixel
        for (int i = 0; i < d.length; i++) {
            if (d[i].getWidth() == 640
                && d[i].getHeight() == 480
                && d[i].getBitsPerPixel() == 32) {
                displayMode = d[i];
                break;
            }
        }
        Display.setDisplayMode(displayMode);
        Display.setTitle(windowTitle);
        Display.create();
    }

    /**
     * Faire toute les initialisation ici, comme le clavier et openGL
     */
    private void init() throws Exception {
   

        
        createWindow();
        
        texture[0] =TextureLoader.getTexture("BMP", ResourceLoader.getResourceAsStream("src/textures/Logo.bmp"));
        texture[1] =TextureLoader.getTexture("BMP", ResourceLoader.getResourceAsStream("src/textures/Mask1.bmp"));
        texture[2] =TextureLoader.getTexture("BMP", ResourceLoader.getResourceAsStream("src/textures/Image1.bmp"));
        texture[3] =TextureLoader.getTexture("BMP", ResourceLoader.getResourceAsStream("src/textures/Mask2.bmp"));
        texture[4] =TextureLoader.getTexture("BMP", ResourceLoader.getResourceAsStream("src/textures/Image2.bmp"));
       
        initGL();
    }

    /**
     * Init OpenGL
     *
     */
    private void initGL() {                                     // All Setup For OpenGL Goes Here
        GL11.glEnable(GL11.GL_TEXTURE_2D);                            // Enable Texture Mapping
        GL11.glShadeModel(GL11.GL_SMOOTH);                            // Enable Smooth Shading
        GL11.glClearColor(0.0f, 0.0f, 0.0f, 0.5f);               // Black Background
        GL11.glClearDepth(1.0f);                                 // Depth Buffer Setup
        GL11.glEnable(GL11.GL_DEPTH_TEST);                            // Enables Depth Testing
        GL11.glMatrixMode(GL11.GL_PROJECTION); // Select The Projection Matrix
        GL11.glLoadIdentity(); // Reset The Projection Matrix

        // Calculate The Aspect Ratio Of The Window
        GLU.gluPerspective(45.0f,
                (float) displayMode.getWidth() / (float) displayMode.getHeight(),
                0.1f,100.0f);
        GL11.glMatrixMode(GL11.GL_MODELVIEW); // Select The Modelview Matrix
        GL11.glLoadIdentity(); // Reset The Modelview Matrix

        // Really Nice Perspective Calculations
        GL11.glHint(GL11.GL_PERSPECTIVE_CORRECTION_HINT, GL11.GL_NICEST);
    }
    /**
     * nettoyage.
     */
    private void Destroy() {
        Display.destroy();
    }

}
